// -------------------------------------------------------------
// BMP to MSX
// XNvgEBhE
//											(C)2000 HRA!
// -------------------------------------------------------------

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "ScriptProc.h"
#include "Resource.h"
#include "utils.h"
#include "config.h"
#include "Setting.h"
#include "calc.h"
#include "ProgProc.h"
#include "winuty.h"
#include "PreView.h"
#include "fileuty.h"

void Converter( SETTING *Mode,int nSrc );			// WndProc.cpp : ϊ֐
#define OFFSET( t,m ) (int)( &( ((t*)NULL)->m ) )	// ItZbgAhXԂ

// -------------------------------------------------------------
// ݒ

#define cnFontSize	16								// XNvg̃tHgTCY
#define TXT_SIZE	30000							// XNvgt@C̍őTCY
#define WORD_MAX	32								// Pő咷
#define MSG_MAX		1024							// bZ[W{bNX

#ifdef _ENGLISH
#define cszFontName	"MS Gothic"						// font of script text.
#else
#define cszFontName	"lr SVbN"					// XNvg̃tHg
#endif

typedef struct {
	char	*word;
	int		id;
} SCRWORD;

typedef bool (*SCRFUNC)( const char *szText,int *ptr );

enum {
	SW_NONE=-1,			// G[
	SW_LOADSETTING=0,	// ݒǍ
	SW_CONVERT,			// ϊ
	SW_SETFILENAME,		// t@Cݒ
	SW_COMMENT,			// Rg
	SW_SCREEN,			// o͉ʃ[h
	SW_MESSAGE,			// bZ[Wo
	SW_SETFLAG,			// etOݒ
	SW_SETTING,			// ݒ_CAO
	SW_PALETTE,			// pbg̐ݒ
	SW_PALMODE,			// pbg̃[hݒ
	SW_CUTERR,			// ؂̂Č덷
	SW_GOSAVAL,			// 덷gUW
	SW_SELCOL,			// IF[h
	SW_DTHADD,			// fBUZ@
	SW_ALGOMODE,		// RASY
};

// -------------------------------------------------------------
// vg^Cv

EVENT( onScriptClose		);
EVENT( onScriptCommand		);
EVENT( onScriptInitDlg		);
EVENT( onScriptPaint		);
EVENT( onScriptWinChg		);
EVENT( onScriptNew			);
EVENT( onScriptOpen			);
EVENT( onScriptSave			);
EVENT( onScriptDropFiles	);
EVENT( onScriptRun			);

static void scrGetWord( const char *szText,int *ptr,char *word,int WordMax );
static int scrSearch( const char *word,SCRWORD *sword,int n );
static void scrSkipSpace( const char *szText,int *ptr );
static bool scrGetString( const char *szText,int *ptr,char *word,int WordMax );
static bool scrGetNumber( const char *szText,int *ptr,int *num );
static inline bool scrIsSpace( char c );

// XNvgR}h֐
bool scrLoadSetting( const char *szText,int *ptr );
bool scrConvert( const char *szText,int *ptr );
bool scrSetFileName( const char *szText,int *ptr );
bool scrComment( const char *szText,int *ptr );
bool scrScreen( const char *szText,int *ptr );
bool scrMessage( const char *szText,int *ptr );
bool scrSetFlag( const char *szText,int *ptr );
bool scrSetting( const char *szText,int *ptr );
bool scrPalette( const char *szText,int *ptr );
bool scrPalMode( const char *szText,int *ptr );
bool scrCutErr( const char *szText,int *ptr );
bool scrGosaVal( const char *szText,int *ptr );
bool scrPalSelMode( const char *szText,int *ptr );
bool scrDthAdd( const char *szText,int *ptr );
bool scrAlgoMode( const char *szText,int *ptr );

// ֐z
static SCRFUNC scrfunc[]={
	scrLoadSetting,				// SW_LOADSETTING
	scrConvert,					// SW_CONVERT
	scrSetFileName,				// SW_SETFILENAME
	scrComment,					// SW_COMMENT
	scrScreen,					// SW_SCREEN
	scrMessage,					// SW_MESSAGE
	scrSetFlag,					// SW_SETFLAG
	scrSetting,					// SW_SETTING
	scrPalette,					// SW_PALETTE
	scrPalMode,					// SW_PALMODE
	scrCutErr,					// SW_CUTERR
	scrGosaVal,					// SW_GOSAVAL
	scrPalSelMode,				// SW_SELCOL
	scrDthAdd,					// SW_DTHADD
	scrAlgoMode,				// SW_ALGOMODE
};

// WndProc
int bdAddFile( const char *cszFileName );
void bdDelete( int Index );

// -------------------------------------------------------------
// O[oϐ

extern HINSTANCE hIns;					// CX^Xnh
extern SETTING	NowMode;				// ݂̐ݒ

static HICON	hIcon = NULL;			// _CAÕACR
static HFONT	hFont = NULL;			// tHg
static HWND		hWnd  = NULL;			// _CAO
static HWND		hText = NULL;			// eLXg{bNX
static SETTING	scrset;					// ϊݒ
static char szTarget[ MAX_PATH ];		// ϊΏۂ̃t@C

// ߌ
static SCRWORD scrword[]={
	{"LOADSETTING"	, SW_LOADSETTING	},
	{"ݒǍ"		, SW_LOADSETTING	},
	{"CONVERT"		, SW_CONVERT		},
	{"ϊ"		, SW_CONVERT		},
	{"SETFILENAME"	, SW_SETFILENAME	},
	{"t@C"	, SW_SETFILENAME	},
	{";"			, SW_COMMENT		},
	{"SCREEN"		, SW_SCREEN			},
	{"ʃ[h"	, SW_SCREEN			},
	{"MSG"			, SW_MESSAGE		},
	{"bZ[W"	, SW_MESSAGE		},
	{"SETFLAG"		, SW_SETFLAG		},
	{"tO"		, SW_SETFLAG		},
	{"SETTING"		, SW_SETTING		},
	{"ݒʕ\"	, SW_SETTING		},
	{"PALETTE"		, SW_PALETTE		},
	{"pbg"		, SW_PALETTE		},
	{"PALMODE"		, SW_PALMODE		},
	{"pbg"	, SW_PALMODE		},
	{"CUTERR"		, SW_CUTERR			},
	{"؂̂Č덷"	, SW_CUTERR			},
	{"GOSAVAL"		, SW_GOSAVAL		},
	{"덷gUW"	, SW_GOSAVAL		},
	{"SELCOLMODE"	, SW_SELCOL			},
	{"IF[h"	, SW_SELCOL			},
	{"DITHERADD"	, SW_DTHADD			},
	{"fBUZ"	, SW_DTHADD			},
	{"ALGOMODE"		, SW_ALGOMODE		},
	{"R搶"	, SW_ALGOMODE		},
};

// tO
static SCRWORD flgword[]={
	{"덷gU"			,OFFSET( SETTING,Gosa		)},		// 덷gU :true / Ȃ:false
	{"GOSA"				,OFFSET( SETTING,Gosa		)},		// 덷gU :true / Ȃ:false
	{"C^[[X"	,OFFSET( SETTING,Inter		)},		// C^[[X :true / Ȃ:false
	{"INTERACE"			,OFFSET( SETTING,Inter		)},		// C^[[X :true / Ȃ:false
	{"Œpbg"		,OFFSET( SETTING,Pal		)},		// Œpbg :true / Ȃ:false
	{"PALNOCHG"			,OFFSET( SETTING,Pal		)},		// Œpbg :true / Ȃ:false
	{"TCY"		,OFFSET( SETTING,Resize		)},		// TCY
	{"RESIZE"			,OFFSET( SETTING,Resize		)},		// TCY
	{"t@C"	,OFFSET( SETTING,AutoName	)},		// t@C
	{"AUTONAME"			,OFFSET( SETTING,AutoName	)},		// t@C
	{"FČvZ"		,OFFSET( SETTING,JKrc		)},		// F̍ČvZ
	{"COLORRECALC"		,OFFSET( SETTING,JKrc		)},		// F̍ČvZ
	{"[gps"		,OFFSET( SETTING,NonZero	)},		// OԂ̐FgȂ
	{"ZERONOUSE"		,OFFSET( SETTING,NonZero	)},		// OԂ̐FgȂ
	{"^C"			,OFFSET( SETTING,Tile		)},		// Ԃ^Cg
	{"TILE"				,OFFSET( SETTING,Tile		)},		// Ԃ^Cg
};

// tOl
static SCRWORD flgbool[]={
	{"TRUE"			,1	},
	{"FALSE"		,0	},
	{"ON"			,1	},
	{"OFF"			,0	},
};

// pbg[h
static SCRWORD flgpmode[]={
	{"NOUSE"		,PALEN_NONE },
	{"AUTO"			,PALEN_AUTO },
	{"CUSTOM"		,PALEN_USE  },
	{"gp"		,PALEN_NONE },
	{""			,PALEN_AUTO },
	{"w"			,PALEN_USE  },
};

// IF[h
static SCRWORD flgselmode[]={
	{"SCATTER"		,SELCOL_BUNSAN	},	// UI
	{"MAX"			,SELCOL_TABUNPU },	// zI
	{"U"			,SELCOL_BUNSAN	},	// UI
	{"z"		,SELCOL_TABUNPU },	// zI
};

// fBUZ[h
static SCRWORD flgdthadd[]={
	{"ROTATE"		,EADD_ROTATE	},	// ]
	{"NONE"			,EADD_NONE		},	// ʑ
	{"X"			,EADD_X			},	// w炵
	{"Y"			,EADD_Y			},	// x炵
	{"]"			,EADD_ROTATE	},	// ]
	{"ʑ"		,EADD_NONE		},	// ʑ
	{"w炵"		,EADD_X			},	// w炵
	{"x炵"		,EADD_Y			},	// x炵
};

// R搶ASY
static SCRWORD flgalgo[]={
	{""			,ALGO_NONE		},	// 
	{"ČvZ"		,ALGO_RECALC	},	// tZɂ덷
	{"pt"		,ALGO_POWERFUL	},	// ptp@̃Cg[VO@ɎgĂ
	{"msrb"	,ALGO_NTSC2		},	// NTSCǔ
	{"F"		,ALGO_RECALC2	},	//	tZɂ덷iFdj
	{"NONE"			,ALGO_NONE		},	// 
	{"RECALC"		,ALGO_RECALC	},	// tZɂ덷
	{"POWERFUL"		,ALGO_POWERFUL	},	// ptp@̃Cg[VO@ɎgĂ
	{"NTSC2"		,ALGO_NTSC2		},	// NTSCǔ
	{"COLOR"		,ALGO_RECALC2	},	//	tZɂ덷iFdj
};

// -------------------------------------------------------------
//	1.	{ꖼ
//		EBhE֐
//	2.	
//		hWnd	...	(I)	EBhEnh
//		msg		...	(I)	bZ[W
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE	...	
//		FALSE	...	
//	4.	l
//		Ȃ
// -------------------------------------------------------------
WINPROC( ScriptProc )
{
	switch( msg )
	{
		ONEVENT( WM_CLOSE				, onScriptClose		);	// 
		ONEVENT( WM_COMMAND				, onScriptCommand	);	// R}h
		ONEVENT( WM_INITDIALOG			, onScriptInitDlg	);	// _CAO
		ONEVENT( WM_PAINT				, onScriptPaint		);	// ĕ`
		ONEVENT( WM_WINDOWPOSCHANGING	, onScriptWinChg	);	// EBhETCYύXO
		ONEVENT( WM_DROPFILES			, onScriptDropFiles	);	// t@Chbv
	}
	return FALSE;
}

// =====================================================
// Cxg

// -------------------------------------------------------------
//	1.	{ꖼ
//		EBhE
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onScriptClose )
{
	if( hFont != NULL ) DeleteObject( hFont );
	if( hIcon != NULL ) DeleteObject( hIcon );
	hIcon = NULL;
	EndDialog( hWnd,0 );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		R}h
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE	...	
//		FALSE	...	
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onScriptCommand )
{
	switch( LOWORD( wp ) )
	{
	// j[Cxg
	ONEVENT( IDM_EXIT		, onScriptClose		);		// 
	ONEVENT( IDM_NEW		, onScriptNew		);		// VK쐬
	ONEVENT( IDM_OPEN		, onScriptOpen		);		// J
	ONEVENT( IDM_SAVE		, onScriptSave		);		// ۑ
	ONEVENT( IDM_RUN		, onScriptRun		);		// s
	}
	return FALSE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		_CAȌ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onScriptInitDlg )
{
	::hWnd = hWnd;
	// ACRZbg
	hIcon = LoadIcon( hIns,MAKEINTRESOURCE( IDI_ICONSCRIPT ) );
	SendMessage( hWnd,WM_SETICON,ICON_BIG  ,(LPARAM)hIcon );
	SendMessage( hWnd,WM_SETICON,ICON_SMALL,(LPARAM)hIcon );
	// tHgZbg
	hFont = CreateFont( cnFontSize,0,0,0,400,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
						FF_DONTCARE | FIXED_PITCH,cszFontName );
	hText = GetDlgItem( hWnd,IDC_SCRIPT );
	SendMessage( hText,WM_SETFONT,(WPARAM)hFont,TRUE );
	Edit_LimitText( hText,TXT_SIZE-1 );							// eLXgő咷
	return TRUE;	// ōŏ̃tH[JX𓖂ĂĂ炤
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ʂ̕`
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onScriptPaint )
{
	HDC			hDC;
	PAINTSTRUCT	ps;

	hDC = BeginPaint( hWnd,&ps );
	EndPaint( hWnd,&ps );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ʃTCYύX
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onScriptWinChg )
{
	RECT r;
	// EBhETCYύX
	GetClientRect( hWnd,&r );
	SetWindowPos( hText,0,0,0,r.right,r.bottom,SWP_NOZORDER );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		VK쐬
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onScriptNew )
{
	int i;
	i = Edit_GetTextLength( hText );
	// mFbZ[W
	if( i ){
		if( MessageBox( hWnd,cszWrnClear,MsgCapWrn,MB_YESNO | MB_ICONWARNING | MB_DEFBUTTON2 )!=IDYES )
			return TRUE;
	}
	// NA
	SetWindowText( hText,"" );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@CJ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onScriptOpen )
{
	char			szFileName[ MAX_PATH ];
	char			szBuf[ TXT_SIZE ],c;
	FU_FILE			*hFile;
	int				i = 0;
	int				tmp;
	OPENFILENAME	ofn;

	// ̧ٖ
	szFileName[0]='\0';
	memset( &ofn, 0, sizeof( ofn ) );
	ofn.lStructSize		= sizeof( ofn );
	ofn.hInstance		= hIns;
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= cszDefScrpt;
	ofn.lpstrCustomFilter= NULL;
	ofn.nFilterIndex	= 1;
	ofn.Flags			= OFN_LONGNAMES | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR;
	ofn.lpstrFile		= szFileName;
	ofn.nMaxFile		= MAX_PATH;
	ofn.lpstrFileTitle	= NULL;
	ofn.lpstrInitialDir	= NULL;	// Jg
	ofn.lpstrTitle		= ScrptLoad;
	if( !GetOpenFileName( &ofn ) ) return TRUE;
	// ̧قǂݍ
	hFile = fu_open( szFileName, "rb" );
	if( hFile == FU_INVALID_HANDLE ){
		MessageBox( hWnd,cszOpenErr,MsgCap,MB_OK | MB_ICONWARNING );
		return TRUE;
	}
	tmp = fu_read( hFile, szBuf, TXT_SIZE );
	if( tmp > TXT_SIZE ){
		szBuf[ TXT_SIZE-1 ]=0;
	}else if( tmp ){
		szBuf[ tmp ]=0;
	}else{
		szBuf[ 0 ]=0;
	}
	// oCif[^ɓǂݏoꍇɂ̓G[ł͂
	while( (c=szBuf[i++])!=0 ){
		if( c=='\t' || c=='\n' || c=='\r' ) continue;
		if( c<32 && c>0 ){
			MessageBox( hWnd,cszNoText,MsgCap,MB_OK | MB_ICONWARNING );
			CloseHandle( hFile );
			return TRUE;
		}
	}
	fu_close( hFile );
	// ǂݍ񂾃eLXgݒ肷
	SetWindowText( hText,szBuf );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ۑ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onScriptSave ) {
	char	szFileName[ MAX_PATH ];
	char	szBuf[ TXT_SIZE ];
	FU_FILE	*hFile;

	// gΉȂ
	if( Edit_GetTextLength( hText )==0 ) return TRUE;
	// t@C擾
	if( !GetName( hWnd, szFileName, MAX_PATH, NULL, cszDefScrpt, NULL ) ) return TRUE;
	// ۑ
	hFile = fu_open( szFileName, "wb" );
	if( hFile == FU_INVALID_HANDLE ) {
		MessageBox( hWnd,cszOpenErr, MsgCap, MB_OK | MB_ICONWARNING );
		return TRUE;
	}
	fu_write( hFile, szBuf, TXT_SIZE );
	fu_close( hFile );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@Chbv
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onScriptDropFiles )
{
	HDROP	hDrop;
	char	szBuf[ MAX_PATH ];
	char	szBuf2[ MAX_PATH ];
	int		i,j;
	hDrop = (HDROP)wp;
	char szText[ TXT_SIZE ];

	// eLXg擾
	GetWindowText( hText,szText,TXT_SIZE );
	// t@C擾
	j=DragQueryFile( hDrop,0xFFFFFFFFL,szBuf,MAX_PATH );
	// o߂\
	GetFileTitle( szBuf, szBuf2, sizeof( szBuf2 ) );
	prShow( szBuf2 );
	// St@C
	for( i=0;i<j;i++ ){
		// hbvꂽt@C擾
		DragQueryFile( hDrop,i,szBuf,MAX_PATH );
		// o߃_CAO̕\XV
		prSetText( szBuf );
		// eLXg
		scrPlayScript( szText,szBuf );
	}
	// o߂폜
	prDestroy();
	// I
	DragFinish( hDrop );
	MessageBox( NULL,cszExit,MsgCap,MB_OK | MB_ICONWARNING );
	return 0;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		s
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onScriptRun )
{
	char szText[ TXT_SIZE ];
	// eLXg擾
	GetWindowText( hText,szText,TXT_SIZE );
	// eLXg
	scrPlayScript( szText,"" );
	MessageBox( NULL,cszExit,MsgCap,MB_OK | MB_ICONWARNING );
	return TRUE;
}

// =====================================================
// XNvg

// -------------------------------------------------------------
//	1.	{ꖼ
//		XNvg
//	2.	
//		szText		...	(O)	XNvgi[惁
//		szFileName	...	(I)	摜t@C
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void scrPlayScript( char *szText,char *szFileName )
{
	char word[ WORD_MAX ];
	int ptr=0;
	int cmd;
	// ݒ
	scrset = NowMode;
	lstrcpy( szTarget,szFileName );
	// [v
	while( szText[ptr]!=0 ){
		// s/zCgXy[Xǂݔ΂
		scrSkipSpace( szText,&ptr );
		// P擾
		scrGetWord( szText,&ptr,word,WORD_MAX );
		if( word[0]==0 ) break;								// ׂĎs
		// PR[h
		cmd = scrSearch( word,scrword,ELMCNT( scrword ) );
		if( cmd != SW_NONE ){
			if( !(scrfunc[cmd])( szText,&ptr ) ) break;		// R}h֐ĂуG[͏I
		}else{
			MessageBox( NULL,cszSyntax,MsgCap,MB_OK | MB_ICONWARNING );
			break;											// sȕ@
		}
		if( szText[ptr]==0 ) break;
	}
	// sIʒuɃJ[\ړ
	Edit_SetSel( hText,ptr,ptr );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		zCgXy[XȂ true,ȊOȂ false Ԃ
//	2.	
//		c	...	(I)	肵iPoCgj
//	3.	Ԓl
//		true	...	Xy[X
//		false	...	Xy[X
//	4.	l
//		VC++6.0SP3  isspace()  -21(0xEB)^ 8 ԂĂ
//		ߓ{ꍬ݂ƎgȂ
// -------------------------------------------------------------
static inline bool scrIsSpace( char c )
{
	return( c==' ' || c=='\t' || c=='\xA' || c=='\xD' );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		zCgXy[Xǂݔ΂
//	2.	
//		szText	...	(I)		eLXg
//		ptr		...	(I/O)	eLXg̎Qƈʒu
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void scrSkipSpace( const char *szText,int *ptr )
{
	while( scrIsSpace( szText[ *ptr ] ) ) ++(*ptr);
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		P̎擾
//	2.	
//		szText	...	(I)		eLXg
//		ptr		...	(I/O)	eLXg̎Qƈʒu
//		word	...	(O)		P̏o͐
//		WordMax	...	(I)		word ̃TCY
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void scrGetWord( const char *szText,int *ptr,char *word,int WordMax )
{
	int i=0;
	--WordMax;
	word[0]=0;
	scrSkipSpace( szText,ptr );
	while( szText[ *ptr ]!='=' && szText[ *ptr ]!=',' && 
		   szText[ *ptr ]!= 0  && !scrIsSpace( szText[ *ptr ] ) && i<WordMax ){
		word[i++]=szText[ (*ptr)++ ];
	}
	word[i]=0;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		XNvg\̌
//	2.	
//		word	...	(I)	P
//		sword	...	(I)	\z
//		n		...	(I)	sword ̗vf
//	3.	Ԓl
//		v΁Asword ̃CfbNX
//		vȂ SW_NONE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static int scrSearch( const char *word,SCRWORD *sword,int n )
{
	int i;
	// 
	for( i=0; i<n; ++i ){
		if( !lstrcmpi( word,sword[i].word ) ) return sword[i].id;
	}
	return SW_NONE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		̎擾
//	2.	
//		szText	...	(I)		eLXg
//		ptr		...	(I/O)	eLXg̎Qƈʒu
//		word	...	(O)		̏o͐
//		WordMax	...	(I)		word ̃TCY
//	3.	Ԓl
//		true	...	
//		false	...	ُ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static bool scrGetString( const char *szText,int *ptr,char *word,int WordMax )
{
	int i=0;
	--WordMax;
	word[0]=0;
	scrSkipSpace( szText,ptr );
	if( szText[ *ptr ] != '\"' ){
		MessageBox( NULL,cszNoString,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	++(*ptr);
	while( (unsigned)szText[ *ptr ]>=' ' && szText[ *ptr ]!='\"' && i<WordMax ){
		word[i++]=szText[ (*ptr)++ ];
	}
	word[i]=0;
	if( szText[ *ptr ]!='\"' ){
		MessageBox( NULL,cszNoDelim,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	++(*ptr);
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		l̎擾
//	2.	
//		szText	...	(I)		eLXg
//		ptr		...	(I/O)	eLXg̎Qƈʒu
//		num		...	(I)		l̊i[
//	3.	Ԓl
//		true	...	
//		false	...	ُ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static bool scrGetNumber( const char *szText,int *ptr,int *num )
{
	int p;
	scrSkipSpace( szText,ptr );
	if( !calc_exp( num,&szText[*ptr],&p ) ) return false;
	*ptr += p;
	return true;
}

// =====================================================
// XNvgR}h

// -------------------------------------------------------------
//	1.	{ꖼ
//		ݒǂݍ
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrLoadSetting( const char *szText,int *ptr )
{
	char filename[ WORD_MAX ];
	// ݒt@C擾
	if( !scrGetString( szText,ptr,filename,WORD_MAX ) ) return false;
	// ݒǂݍ
	if( !GetCfgFile( &scrset,filename ) ){
		MessageBox( NULL,cszNoCfg,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ϊs
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrConvert( const char *szText,int *ptr )
{
	int n;
	// t@Cݒ肳ĂȂΏI
	if( szTarget[0]==0 ){
		MessageBox( NULL,cszNoFile,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// _CAO{bNX\
	prShow( szTarget );
	// ϊ
	if( (n=bdAddFile( szTarget ))==-1 ){
		MessageBox( NULL,cszBDErr,MsgCap,MB_OK | MB_ICONWARNING );
		prDestroy();
		return 0;
	}
	Converter( &scrset,n );
	// p
	if( scrset.PreView == 1 ){
		bdDelete(n);
	}
	prDestroy();
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@Cݒ肷
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrSetFileName( const char *szText,int *ptr )
{
	// ݒt@C擾
	if( !scrGetString( szText,ptr,szTarget,WORD_MAX ) ) return false;
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		Rg
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrComment( const char *szText,int *ptr )
{
	// RgIisj܂Ń|C^ړ
	while( szText[ *ptr ]!='\xA' && szText[ *ptr ]!='\xD' && szText[ *ptr ]!=0 ) ++(*ptr);
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		o̓[hύX
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrScreen( const char *szText,int *ptr )
{
	int m;
	// l
	if( !calc_exp( &m,szText,ptr ) ){
		MessageBox( NULL,cszScrMode,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// 
	switch( m ){
	case 2:		m=MD_SC2;	break;
	case 3:		m=MD_SC3;	break;
	case 4:		m=MD_SC2;	break;
	case 5:		m=MD_SC5;	break;
	case 6:		m=MD_SC6;	break;
	case 7:		m=MD_SC7;	break;
	case 8:		m=MD_SC8;	break;
	case 10:	m=MD_SC10;	break;
	case 11:	m=MD_SC10;	break;
	case 12:	m=MD_SC12;	break;
	default:
		MessageBox( NULL,cszScrMode,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	scrset.Mode = m;
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		bZ[W{bNX\
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrMessage( const char *szText,int *ptr )
{
	char word[ MSG_MAX ];
	// ݒt@C擾
	if( !scrGetString( szText,ptr,word,MSG_MAX ) ) return false;
#ifdef _ENGLISH
	MessageBox( NULL,word,"Message",MB_OK );
#else
	MessageBox( NULL,word,"ү",MB_OK );
#endif
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		e׸ނ̐ݒ
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrSetFlag( const char *szText,int *ptr )
{
	char word[ WORD_MAX ];
	int p,b;
	// P̎擾
	scrGetWord( szText,ptr,word,WORD_MAX );
	if( word[0]==0 ){
		MessageBox(  NULL,cszNoFlag,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// P̌
	p = scrSearch( word,flgword,ELMCNT( flgword ) );
	if( p==SW_NONE || szText[ *ptr ]==0 ){
		MessageBox(  NULL,cszNoFlag,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// '=' ̋Lǂݔ΂
	scrSkipSpace( szText,ptr );
	++(*ptr);
	scrSkipSpace( szText,ptr );
	// tO̐ݒlǂݍ
	scrGetWord( szText,ptr,word,WORD_MAX );
	if( word[0]==0 ){
		MessageBox(  NULL,cszNoBool,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// tOľ
	b = scrSearch( word,flgbool,ELMCNT( flgbool ) );
	if( b==SW_NONE ){
		MessageBox(  NULL,cszNoBool,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// l̑
	*((bool*)(((char*)&scrset)+p)) = (b!=0);
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ϊݒύX_CAO̕\
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrSetting( const char *szText,int *ptr )
{
	// [hݒҏWGAփRs[
	EdtMode = scrset;
	lstrcpy( szCaption,cszScrSetting );
	if( DialogBox( hIns,MAKEINTRESOURCE( IDD_SETTING ),hWnd,(DLGPROC)SetProc )==0 ){
		scrset = EdtMode;
	}
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		pbg̐ݒ薽
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrPalette( const char *szText,int *ptr )
{
	int p,r,g,b;
	// pbgԍ擾
	if( !calc_exp( &p,szText,ptr ) ){
		MessageBox( NULL,cszPal,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	++(*ptr);
	// Ԃ̐ݒl擾
	if( !calc_exp( &r,szText,ptr ) ){
		MessageBox( NULL,cszPal,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	++(*ptr);
	// ΂̐ݒl擾
	if( !calc_exp( &g,szText,ptr ) ){
		MessageBox( NULL,cszPal,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	++(*ptr);
	// Ԃ̐ݒl擾
	if( !calc_exp( &b,szText,ptr ) ){
		MessageBox( NULL,cszPal,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// ͈͊O
	if( p<0 || p>15 || r<0 || r>7 || g<0 || g>7 || b<0 || b>7 ){
		MessageBox( NULL,cszPal,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// pbgݒ肷
	scrset.Col[p].red   = r;
	scrset.Col[p].green = g;
	scrset.Col[p].blue  = b;
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		pbg̗LԂ̐ݒ薽
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrPalMode( const char *szText,int *ptr )
{
	char word[ WORD_MAX ];
	int p,b;
	// pbgԍ擾
	if( !calc_exp( &p,szText,ptr ) ){
		MessageBox( NULL,cszPal,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	++(*ptr);
	// tO̐ݒlǂݍ
	scrGetWord( szText,ptr,word,WORD_MAX );
	if( word[0]==0 ){
		MessageBox(  NULL,cszPMode,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// tOľ
	b = scrSearch( word,flgpmode,ELMCNT( flgpmode ) );
	if( b==SW_NONE ){
		MessageBox(  NULL,cszPMode,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// l̑
	scrset.PalEn[p] = b;
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		؂̂Č덷l̐ݒ薽
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrCutErr( const char *szText,int *ptr )
{
	int r;
	// ؂̂Č덷̒l擾
	if( !calc_exp( &r,szText,ptr ) ){
		MessageBox( NULL,cszCutErr,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// ͈͊O`FbN
	if( r<0 || r>255 ){
		MessageBox( NULL,cszCutErr,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	scrset.err = r;
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		덷gUWݒ薽
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrGosaVal( const char *szText,int *ptr )
{
	int r;
	// ؂̂Č덷̒l擾
	if( !calc_exp( &r,szText,ptr ) ){
		MessageBox( NULL,cszGosaVal,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// ͈͊O`FbN
	if( r<0 || r>500 ){
		MessageBox( NULL,cszGosaVal,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	scrset.Gosaval = (float)r/1000.0f;
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		IF[hݒ薽
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrPalSelMode( const char *szText,int *ptr )
{
	char word[ WORD_MAX ];
	int b;
	// tO̐ݒlǂݍ
	scrGetWord( szText,ptr,word,WORD_MAX );
	if( word[0]==0 ){
		MessageBox(  NULL,cszSelMode,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// tOľ
	b = scrSearch( word,flgselmode,ELMCNT( flgselmode ) );
	if( b==SW_NONE ){
		MessageBox(  NULL,cszSelMode,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// l̑
	scrset.SelCol = b;
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		fBUZ@ݒ薽
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrDthAdd( const char *szText,int *ptr )
{
	char word[ WORD_MAX ];
	int a;
	// tO̐ݒlǂݍ
	scrGetWord( szText,ptr,word,WORD_MAX );
	if( word[0]==0 ){
		MessageBox(  NULL,cszSelMode,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// tOľ
	a = scrSearch( word,flgdthadd,ELMCNT( flgdthadd ) );
	if( a==SW_NONE ){
		MessageBox(  NULL,cszSelMode,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// l̑
	scrset.ErrAdd = a;
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		R搶ASYݒ薽
//	2.	
//		szText	...	(I)	eLXg
//		ptr		...	(I)	eLXg̎Qƈʒu
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool scrAlgoMode( const char *szText,int *ptr )
{
	char word[ WORD_MAX ];
	int a;
	// tO̐ݒlǂݍ
	scrGetWord( szText,ptr,word,WORD_MAX );
	if( word[0]==0 ){
		MessageBox(  NULL,cszSelMode,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// tOľ
	a = scrSearch( word,flgalgo,ELMCNT( flgalgo ) );
	if( a==SW_NONE ){
		MessageBox(  NULL,cszSelMode,MsgCap,MB_OK | MB_ICONWARNING );
		return false;
	}
	// l̑
	scrset.AlgoMode = a;
	return true;
}
