// -------------------------------------------------------------
// BMP to MSX
// ݒ_CAO
//											(C)2000/5/6 HRA!
// -------------------------------------------------------------

#include <windows.h>
#include <windowsx.h>
#include "Config.h"
#include "Setting.h"
#include "Resource.h"
#include <commctrl.h>
#include "Convert.h"
#include "utils.h"
#include "winuty.h"
#include "bsave.h"
#include "fileuty.h"

// -------------------------------------------------------------
// e[u
// -------------------------------------------------------------
// o͉ʃ[hR{{bNX̓e
const char *ScrModeName[]={
	"SCREEN2/4",
	"SCREEN3",
	"SCREEN5",
	"SCREEN6",
	"SCREEN7",
	"SCREEN8",
	"SCREEN10/11",
	"SCREEN12",
	"SCREEN5(256lines)",
	"SCREEN6(256lines)",
	"SCREEN7(256lines)",
	"SCREEN8(256lines)",
	"SCREEN10/11(256lines)",
	"SCREEN12(256lines)",
};

//	c[`bv`
typedef struct {
	int		nId;
	char*	sStr;
} TOOLTIPS;

#ifdef _ENGLISH	// p(English)
// pbgo̓[h
const char *PltMode[]={		// vfԍ PLT_XXXX ̒`ƈv
	"no output",
	"into the picture file( COLOR=RESTORE ver. )",
	"*.PL? ( (C)BIT2 Graphsaurus v2.x ver. )",
	"*.CSV ( CSV text file )",
};

// ٺؽі
const char *AlgoName[]={		// vfԍ ALGO_XXXX ̒`ƈv
	"no use",
	"error fix (give brightness)",
	"MSX2+ POWERFUL BOOK ver.",
	"NTSC fix(R:G:B=40:49:6)",
	"error fix (give tone)"
};

// fBUp^[
const char *ErrAlgoName[]={	// vfԍ EALGO_XXXX ̒`ƈv
	"no use",
	"random dots",
	"net dots",
	"net dots(double length)",
	"pattern of brick",
	"pattern of grain",
	"rough net",
	"lite net",
	"half tone",
};

// vr[[h
const char *PreViewName[]={
	"file",
	"preview",
	"file and preview",
};

// FČx
const char *ColorSeido[]={
	"8bit",
	"7bit",
	"6bit",
	"5bit",
	"4bit",
};

// fBUZ@
const char *ErrAlgo2Name[]={
	"rotate",
	"pile up",
	"move X",
	"move Y",
};

// pbggp
const char *PalEnName[]={
	"automatic color",
	"no use",
	"customize color",
};

// [
const char *FZColorName[]={
	"no use",
	"appointed color No. -> No.0",
	"appointed (X,Y) color -> No.0",
};

const char *cOpenFile = "Open File";

static const TOOLTIPS ttips[] = {
	IDC_CMBSCREEN	,	"select a screen mode of MSX",
	IDC_PREVIEW		,	"select an output point (a preview, a file)",
	IDC_CMBERR		,	"select shape of pattern to increase the number of color",
	IDC_CMBERR2		,	"select it how I apply dither pattern in each element of RGB",
	IDC_SEIDO		,	"use high rank several bits of a former image as an effective value",
	IDC_GOSA		,	"scatter an error and do not stand out and do it",
	IDC_GOSAVAL		,	"appoint a value to let the error that spread splash it on each other. small and spread becomes weak",
	IDC_GOSAERR		,	"appoint the threshold value cutting off the error that spread. then spread becomes greatly weak",
	IDC_INTER		,	"use an inter race mode of MSX and double resolution of perpendicular course",
	IDC_RESIZE		,	"an image is destroyed by the ratio regulating an input image in output size forcibly",
	IDC_JKRC		,	"I calculate J/K value which is most suitable for Y value which I calculated after Y decision again and revise it",
	IDC_AUTONAME	,	"I make the output file name from the input file name and do not display a file excellent input column",
	IDC_CMBALGO		,	"select a method of SCREEN10/12",
	IDC_SELCOL		,	"I select a lot of colors using with precedence (a color of outline lines may not be selected)",
	IDC_PAL			,	"I do not generate a color of a palette automatically",
	IDC_CHKZERO		,	"I do not use a color of the 0 and move it in other colors (for TPSET)",
	IDC_TILE		,	"A net of ratio handles a design as an usual color at 1:1 of extremely near color and increases a color",
	IDC_ENREVS		,	"apply automatic decision setting of color set beneath to all palettes",
	IDC_PALEN		,	"I select it whether I decide a color automatically whether I appoint a value",
	IDC_FZERO		,	"I select a method of the color appointment that turns a color of specification into a color of the 0 forcibly (for TPSET)",
	IDC_FZCOLOR		,	"It is a button to appoint a color to turn into the 0 forcibly",
	IDC_FZC			,	"It is a color to turn into the 0 forcibly",
	IDC_FZ_X		,	"It is a coordinate at gathering a color from an image to turn into the 0 forcibly",
	IDC_FZ_Y		,	"It is a coordinate at gathering a color from an image to turn into the 0 forcibly",
	IDC_CMBPLT		,	"I appoint an output method of a palette",
	IDC_LOADPLT		,	"Reading adds to a palette file",
	IDC_MSX1COLOR	,	"turn a palette into a color of MSX1",
	IDC_192			,	"I output an image for a 192 line (an inter race, 384 line) when I put a check.",
	IDC_SORT		,	"I appoint a method to let a color stand in line of a palette.",
	IDC_SAVEAS		,	"I store setting displaying in a file currently.",
	IDC_LOAD		,	"Reading adds to the setting file which I stored formerly.",
	IDC_DEFAULT		,	"I adopt setting contents displaying as \'default setting\'.",
	IDC_CHKDEF		,	"Setting at having done re-conversion is copied immediately by default setting when I put a check.",
	IDC_CMBCNV		,	"I appoint setting to adopt when I convert a new image file into.",
	IDC_FILLC		,	"I smash it, and a method of coating to initialize it is a color",
	IDC_SIZEMODE	,	"I appoint a decision method of aspect ratio",
	IDC_RESAMPLE	,	"I appoint a sample method of color.",
};

const char *SortMode[] = {
	"Ignore",
	"Incriment(auto only)",
	"Decriment(auto only)",
	"Incriment",
	"Decriment",
};

const char *UseSetting[] = {
	"Default",
	"Last convert",
	"Indication image",
};

const char *Resample[] = {
	"normal",
	"antialiasing",
};

const char *SizeMode[] = {
	"output size forcibly",
	"look like aspect ratio on MSX",
};

#else			// {(Japanese)

// pbgo̓[h
const char *PltMode[]={		// vfԍ PLT_XXXX ̒`ƈv
	"o͂Ȃ",
	"摜Ɍ(COLOR=RESTOREp)",
	"OtTEX *.PL? `",
	"CSV`",
};

// ٺؽі
const char *AlgoName[]={		// vfԍ ALGO_XXXX ̒`ƈv
	"Ȃ",
	"덷iPxdj",
	"MSX2+يp@ڲڕ",
	"NTSC(R:G:B=40:49:6)",
	"덷iFdj"
};

// fBUp^[
const char *ErrAlgoName[]={	// vfԍ EALGO_XXXX ̒`ƈv
	"Ȃ",
	"^_",
	"xȖԂ",
	"c̖Ԃ",
	"K͗l",
	"ԂԖ͗l",
	"eԂ",
	"Ԃ",
	"n[tg[",
};

// vr[[h
const char *PreViewName[]={
	"t@C֏o",
	"vr[̂ݍ쐬",
	"vr[쐬ăt@C֏o",
};

// FČx
const char *ColorSeido[]={
	"8bit",
	"7bit",
	"6bit",
	"5bit",
	"4bit",
};

// fBUZ@
const char *ErrAlgo2Name[]={
	"]",
	"ʑ",
	"w炵",
	"x炵",
};

// pbggp
const char *PalEnName[]={
	"F",
	"gp",
	"ݒFgp",
};

// [
const char *FZColorName[]={
	"gpȂ",
	"wFۉ",
	"wWFۉ",
};

const char *cOpenFile = "t@CJ";

static const TOOLTIPS ttips[] = {
	IDC_CMBSCREEN	,	"MSX ̉ʃ[hI܂",
	IDC_PREVIEW		,	"o͐ivr[At@CjI܂",
	IDC_CMBERR		,	"[IɐF𑝂₷߂̃p^[̌`I܂",
	IDC_CMBERR2		,	"RGB̊evfɂǂ̂悤ɃfBUp^[Kp邩I܂",
	IDC_SEIDO		,	"摜̏ʉrbgLlƂĎgp邩I܂",
	IDC_GOSA		,	"덷gUĖڗȂ܂",
	IDC_GOSAVAL		,	"gU덷Ɋ|킹lw肵܂AƊgUキȂ܂",
	IDC_GOSAERR		,	"gU덷؂̂Ă~lw肵܂A傫ƊgUキȂ܂",
	IDC_INTER		,	"MSX̃C^[[X[hgĐ̉𑜓xQ{ɂ܂",
	IDC_RESIZE		,	"͉摜̃TCYߕ@gp邩ۂw肵܂",
	IDC_JKRC		,	"Zo Y lɍœK J/K l Y ɍČvZĕ␳܂",
	IDC_AUTONAME	,	"o̓t@C̓t@C쐬At@C͗\ȂȂ܂",
	IDC_CMBALGO		,	"R挸F̕@I܂",
	IDC_SELCOL		,	"gĂFDIɑIт܂i֊sȂǂ̐FI΂Ȃ\܂j",
	IDC_PAL			,	"pbg̐F܂",
	IDC_CHKZERO		,	"0Ԃ̐Fg킸Aʂ̐Fɒu܂iTPSETpj",
	IDC_TILE		,	"߂F 1:1 䗦̖Ԃ͗lʏ̐FƂĈ[IɐF𑝂₵܂",
	IDC_ENREVS		,	"ɐݒ肵ĂF̎ݒSẴpbgɓKp܂",
	IDC_PALEN		,	"FIɌ肷邩Alw肷邩I܂",
	IDC_FZERO		,	"̐FI 0Ԃ̐Fɂ܂iTPSETpjA̐Fw̕@I܂",
	IDC_FZCOLOR		,	"I 0ԂɂFw肷{^ł",
	IDC_FZC			,	"I 0ԂɂFł",
	IDC_FZ_X		,	"I 0ԂɂF摜̎悷ꍇ̍Wł",
	IDC_FZ_Y		,	"I 0ԂɂF摜̎悷ꍇ̍Wł",
	IDC_CMBPLT		,	"pbg̏o͕@w肵܂",
	IDC_LOADPLT		,	"pbgt@Cǂݍ݂܂",
	IDC_MSX1COLOR	,	"pbglrwP̐Fɂ܂",
	IDC_192			,	"`FbN192CiC^[[X384Cjp̉摜o͂܂",
	IDC_SORT		,	"pbg̐F𐮗񂳂@w肵܂",
	IDC_SAVEAS		,	"ݕ\Ăݒt@Cɕۑ܂",
	IDC_LOAD		,	"ȑOۑݒt@Cǂݍ݂܂A݂̕\e͏Ă܂̂łӂ",
	IDC_DEFAULT		,	"ݕ\Ăݒe ftHg̐ݒ Ƃč̗p܂",
	IDC_CHKDEF		,	"`FbNƁAĕϊsƂ̐ݒ肪܃ftHgݒɃRs[܂",
	IDC_CMBCNV		,	"V摜t@CϊƂɍ̗pݒw肵܂",
	IDC_FILLC		,	"摜݂̑Ȃ̐FŖ߂܂Bpbgɂeꍇ̂Œ",
	IDC_SIZEMODE	,	"č@w肵܂",
	IDC_RESAMPLE	,	"TCY߂̍ۂ́AF̃TvO@w肵܂BʓIɃm[}̏ꍇAk摜͌򉻂܂B",
};

const char *SortMode[] = {
	"܂",
	"̂ݏ",
	"̂ݍ~",
	"S",
	"S~",
};

const char *UseSetting[] = {
	"̫Đݒ",
	"Ō̕ϊݒ",
	"\摜̐ݒ",
};

const char *Resample[] = {
	"ɰ",
	"ر",
};

const char *SizeMode[] = {
	"Iɏoͻނɂ킹",
	"MSXœcɌ黲",
};

#endif

// e[hɉRg[̗LE
static const int nCtrlCode[]={
	IDC_GOSA,IDC_GOSAVAL,IDC_GOSAERR,IDC_PAL,IDC_SELCOL,IDC_CMBPLT,IDC_COLTBL,IDC_LOADPLT,IDC_RED,IDC_GREEN,IDC_BLUE,IDC_CMBALGO,IDC_JKRC,IDC_PALEN,IDC_ENREVS,IDC_CMBERR2,IDC_TILE,IDC_SORT,IDC_INTER,IDC_MSX1COLOR,IDC_192,IDC_SAVEPLT,
};

static const BOOL nCtrlEnbl[][ ELMCNT(nCtrlCode) ]={
	{TRUE	,TRUE		,TRUE		,TRUE	,TRUE	  ,TRUE		  ,TRUE		,TRUE		 ,TRUE	 ,TRUE	   ,TRUE	,FALSE		,FALSE	 ,TRUE	   ,TRUE	  ,TRUE		  ,TRUE	   ,TRUE    , FALSE	  ,TRUE			,FALSE	,TRUE  },	// SCREEN2/4
	{TRUE	,TRUE		,TRUE		,TRUE	,TRUE	  ,TRUE		  ,TRUE		,TRUE		 ,TRUE	 ,TRUE	   ,TRUE	,FALSE		,FALSE	 ,TRUE	   ,TRUE	  ,TRUE		  ,TRUE	   ,TRUE    , FALSE	  ,TRUE			,FALSE	,TRUE  },	// SCREEN3
	{TRUE	,TRUE		,TRUE		,TRUE	,TRUE	  ,TRUE		  ,TRUE		,TRUE		 ,TRUE	 ,TRUE	   ,TRUE	,FALSE		,FALSE	 ,TRUE	   ,TRUE	  ,TRUE		  ,TRUE	   ,TRUE    , TRUE	  ,TRUE			,TRUE	,TRUE  },	// SCREEN5
	{TRUE	,TRUE		,TRUE		,TRUE	,TRUE	  ,TRUE		  ,TRUE		,TRUE		 ,TRUE	 ,TRUE	   ,TRUE	,FALSE		,FALSE	 ,TRUE	   ,TRUE	  ,TRUE		  ,TRUE	   ,TRUE    , TRUE	  ,TRUE			,TRUE	,TRUE  },	// SCREEN6
	{TRUE	,TRUE		,TRUE		,TRUE	,TRUE	  ,TRUE		  ,TRUE		,TRUE		 ,TRUE	 ,TRUE	   ,TRUE	,FALSE		,FALSE	 ,TRUE	   ,TRUE	  ,TRUE		  ,TRUE	   ,TRUE    , TRUE	  ,TRUE			,TRUE	,TRUE  },	// SCREEN7
	{TRUE	,TRUE		,TRUE		,FALSE	,FALSE	  ,FALSE	  ,FALSE	,FALSE		 ,FALSE	 ,FALSE	   ,FALSE	,FALSE		,FALSE	 ,FALSE	   ,FALSE	  ,TRUE		  ,TRUE	   ,FALSE   , TRUE	  ,FALSE		,TRUE	,FALSE },	// SCREEN8
	{TRUE	,TRUE		,TRUE		,FALSE	,FALSE	  ,FALSE	  ,FALSE	,FALSE		 ,FALSE	 ,FALSE	   ,FALSE	,TRUE		,TRUE	 ,FALSE	   ,FALSE	  ,FALSE	  ,FALSE   ,FALSE   , TRUE	  ,FALSE		,TRUE	,FALSE },	// SCREEN10/11
	{TRUE	,TRUE		,TRUE		,FALSE	,FALSE	  ,FALSE	  ,FALSE	,FALSE		 ,FALSE	 ,FALSE	   ,FALSE	,TRUE		,TRUE	 ,FALSE	   ,FALSE	  ,FALSE	  ,FALSE   ,FALSE   , TRUE	  ,FALSE		,TRUE	,FALSE },	// SCREEN12
	{TRUE	,TRUE		,TRUE		,TRUE	,TRUE	  ,TRUE		  ,TRUE		,TRUE		 ,TRUE	 ,TRUE	   ,TRUE	,FALSE		,FALSE	 ,TRUE	   ,TRUE	  ,TRUE		  ,TRUE	   ,TRUE    , TRUE	  ,TRUE			,TRUE	,TRUE  },	// SCREEN5 (256 lines)
	{TRUE	,TRUE		,TRUE		,TRUE	,TRUE	  ,TRUE		  ,TRUE		,TRUE		 ,TRUE	 ,TRUE	   ,TRUE	,FALSE		,FALSE	 ,TRUE	   ,TRUE	  ,TRUE		  ,TRUE	   ,TRUE    , TRUE	  ,TRUE			,TRUE	,TRUE  },	// SCREEN6 (256 lines)
	{TRUE	,TRUE		,TRUE		,TRUE	,TRUE	  ,TRUE		  ,TRUE		,TRUE		 ,TRUE	 ,TRUE	   ,TRUE	,FALSE		,FALSE	 ,TRUE	   ,TRUE	  ,TRUE		  ,TRUE	   ,TRUE    , TRUE	  ,TRUE			,TRUE	,TRUE  },	// SCREEN7 (256 lines)
	{TRUE	,TRUE		,TRUE		,FALSE	,FALSE	  ,FALSE	  ,FALSE	,FALSE		 ,FALSE	 ,FALSE	   ,FALSE	,FALSE		,FALSE	 ,FALSE	   ,FALSE	  ,TRUE		  ,TRUE	   ,FALSE   , TRUE	  ,FALSE		,TRUE	,FALSE },	// SCREEN8 (256 lines)
	{TRUE	,TRUE		,TRUE		,FALSE	,FALSE	  ,FALSE	  ,FALSE	,FALSE		 ,FALSE	 ,FALSE	   ,FALSE	,TRUE		,TRUE	 ,FALSE	   ,FALSE	  ,FALSE	  ,FALSE   ,FALSE   , TRUE	  ,FALSE		,TRUE	,FALSE },	// SCREEN10/11 (256 lines)
	{TRUE	,TRUE		,TRUE		,FALSE	,FALSE	  ,FALSE	  ,FALSE	,FALSE		 ,FALSE	 ,FALSE	   ,FALSE	,TRUE		,TRUE	 ,FALSE	   ,FALSE	  ,FALSE	  ,FALSE   ,FALSE   , TRUE	  ,FALSE		,TRUE	,FALSE },	// SCREEN12 (256 lines)
};

SETTING EdtMode;
extern SETTING NowMode;
extern bool bSave;		// WndProc.cpp

// -------------------------------------------------------------
// vg^Cv
// -------------------------------------------------------------
EVENT( onSetClose		);
EVENT( onSetCommand		);
EVENT( onSetHScroll		);
EVENT( onSetInitDlg		);
EVENT( onSetInter		);
EVENT( onSetLoadPlt		);
EVENT( onSetMode		);
EVENT( onSetOk			);
EVENT( onSetGosa		);
EVENT( onSetPal			);
EVENT( onSetPltMode		);
EVENT( onSetResize		);
EVENT( onSetResample	);
EVENT( onSetSizeMode	);
EVENT( onSetSelCol		);
EVENT( onSetAutoName	);
EVENT( onSetAlgo		);
EVENT( onSetJKrc		);
EVENT( onSetErr			);
EVENT( onSetPreView		);
EVENT( onSetPalEnable	);
EVENT( onSetEnRevs		);
EVENT( onSetSaveAs		);
EVENT( onSetLoad		);
EVENT( onSetSeido		);
EVENT( onSetErrAdd		);
EVENT( onSetNonZero		);
EVENT( onSetFZero		);
EVENT( onSetFZColor		);
EVENT( onSetFCColor		);
EVENT( onSetFZX			);
EVENT( onSetFZY			);
EVENT( onSetTile		);
EVENT( onSetSort		);
EVENT( onSetDefault		);
EVENT( onSetChkDef		);
EVENT( onSetCmbCnv		);
EVENT( onSetMSX1		);
EVENT( onSet192			);
EVENT( onSetSavePlt		);

EVENT( onColRButtonDown	);
EVENT( onColLButtonDown	);
EVENT( onColPaint		);
EVENT( onColMouseMove	);
EVENT( onColLButtonUp	);

EVENT( onFZPaint		);
EVENT( onFCPaint		);

static void UpdateColor( int c );
static void SetEditColor( HWND hWnd,int c,bool s );
static void ChangeColor( int p1, int p2 );

static inline void SetSliderRange( HWND hWnd,short int max,short int min );
static inline void SetSliderValue( HWND hWnd,short int val );
static void LoadPLFile( const char *szFileName );
static void SetCtlEnable( HWND hWnd );
static void ComboBox_Init( HWND hWnd,int id,const char **sArray,int n,int index );
static void UpdateAll( HWND hWnd );
static void _enddlg( HWND hWnd,int exitcode );

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
static HDC		hMemDC = NULL;			// J[e[ui[pfoCX
static HBITMAP	hMemBM = NULL;			// J[e[ui[prbg}bv
static int w,h;							// J[e[ũTCY
static int NowCol=0;					// ݕҏW̐F
static WNDPROC	ColProc = NULL;			// pbg̃ftHgEBhE֐
static WNDPROC	FZProc = NULL;			// [F̃ftHgEBhE֐
static WNDPROC	FCProc = NULL;			// wiF̃ftHgEBhE֐
static bool bDraging = false;			// pbghbOۂ
extern HINSTANCE	hIns;				// CX^Xnh( main.cpp )
bool bRedo			= false;			// ĕϊ̫Đݒ肩
char szCaption[ 256 ]="";				// ^Cg
static COLORREF	CustColors[16]={		// FI_CAOŎgpJX^J[
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
};

// -------------------------------------------------------------
// Cxg

// -------------------------------------------------------------
//	1.	{ꖼ
//		EBhE֐
//	2.	
//		hWnd	...	(I)	EBhEnh
//		msg		...	(I)	bZ[W
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -------------------------------------------------------------
WINPROC( SetProc )
{
	switch( msg )
	{
		ONEVENT( WM_CLOSE		, onSetClose	);
		ONEVENT( WM_COMMAND		, onSetCommand	);
		ONEVENT( WM_HSCROLL		, onSetHScroll	);
		ONEVENT( WM_INITDIALOG	, onSetInitDlg	);
	}
	return FALSE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		J[pbg̃TuNX֐
//	2.	
//		hWnd	...	(I)	EBhEnh
//		msg		...	(I)	bZ[W
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -------------------------------------------------------------
WINPROC( SubColProc )
{
	switch( msg )
	{
		ONEVENT( WM_RBUTTONDOWN	, onColRButtonDown	);
		ONEVENT( WM_LBUTTONDOWN	, onColLButtonDown	);
		ONEVENT( WM_PAINT		, onColPaint		);
		ONEVENT( WM_MOUSEMOVE	, onColMouseMove	);
		ONEVENT( WM_LBUTTONUP	, onColLButtonUp	);
	}
	return CallWindowProc( ColProc, hWnd, msg, wp, lp );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		[F\̃TuNX֐
//	2.	
//		hWnd	...	(I)	EBhEnh
//		msg		...	(I)	bZ[W
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -------------------------------------------------------------
WINPROC( SubFZProc )
{
	switch( msg )
	{
		ONEVENT( WM_PAINT		, onFZPaint			);
	}
	return CallWindowProc( FZProc, hWnd, msg, wp, lp );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		wiF\̃TuNX֐
//	2.	
//		hWnd	...	(I)	EBhEnhv
//		msg		...	(I)	bZ[W
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -------------------------------------------------------------
WINPROC( SubFCProc )
{
	switch( msg )
	{
		ONEVENT( WM_PAINT		, onFCPaint			);
	}
	return CallWindowProc( FCProc, hWnd, msg, wp, lp );
}

// -------------------------------------------------------------
// ʃCxg

// -------------------------------------------------------------
//	1.	{ꖼ
//		_CAȌ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetInitDlg )
{
	HDC		hDC;
	RECT	r;
	HWND	hCol;
	HWND	hTip;
	int		i;

	// ^Cg
	SetWindowText( hWnd,szCaption );
	SetDlgItemText( hWnd, IDOK, szCaption );

	//	[F̃TuNX
	hCol = GetDlgItem( hWnd, IDC_FZC );
	FZProc = (WNDPROC) GetWindowLong( hCol, GWL_WNDPROC );
	SetWindowLong( hCol, GWL_WNDPROC, (LONG)SubFZProc );

	//	wiF̃TuNX
	hCol = GetDlgItem( hWnd, IDC_FILLCOLOR );
	FCProc = (WNDPROC) GetWindowLong( hCol, GWL_WNDPROC );
	SetWindowLong( hCol, GWL_WNDPROC, (LONG)SubFCProc );

	//	J[pbg̃TuNXƃrbg}bv̍쐬
	hCol = GetDlgItem( hWnd, IDC_COLTBL );
	ColProc = (WNDPROC) GetWindowLong( hCol, GWL_WNDPROC );
	SetWindowLong( hCol, GWL_WNDPROC, (LONG)SubColProc );

	hDC = GetDC( hWnd );
	GetClientRect( hCol, &r );
	w = r.right;
	h = r.bottom;
	hMemDC = CreateCompatibleDC( hDC );
	hMemBM = CreateCompatibleBitmap( hDC, w, h );
	if( hMemDC == NULL || hMemBM == NULL ) return TRUE;
	SelectBrush( hMemDC,GetStockBrush( NULL_BRUSH ) );
	SelectBitmap( hMemDC,hMemBM );
	UpdateAll( hWnd );

	//	c[`bvt
	hTip = wu_ttip_create( hWnd );
	for( i = 0; i < ELMCNT( ttips ); ++i ) {
		wu_ttip_set_item( hTip, ttips[i].nId, ttips[i].sStr );
	}

	return TRUE;	// ōŏ̃tH[JX𓖂ĂĂ炤
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		EBhE / {^FLZ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetClose )
{
	_enddlg( hWnd,-1 );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		R}h
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetCommand )
{
	switch( LOWORD( wp ) )
	{
	// eLXg{bNX
	ONEVENT( IDC_FZ_X		, onSetFZX		);		// [wW
	ONEVENT( IDC_FZ_Y		, onSetFZY		);		// [xW
	// {^
	ONEVENT( IDOK			, onSetOk		);		// OK
	ONEVENT( IDCANCEL		, onSetClose	);		// ݾ
	ONEVENT( IDC_LOADPLT	, onSetLoadPlt	);		// گēǂݍ
	ONEVENT( IDC_ENREVS		, onSetEnRevs	);		// Sē
	ONEVENT( IDC_SAVEAS		, onSetSaveAs	);		// t@C֕ۑ
	ONEVENT( IDC_LOAD		, onSetLoad		);		// t@Cǂݏo
	ONEVENT( IDC_FZCOLOR	, onSetFZColor	);		// ۉFw
	ONEVENT( IDC_FILLC		, onSetFCColor	);		// wiFw
	ONEVENT( IDC_DEFAULT	, onSetDefault	);		// ̫Ăֺ߰
	ONEVENT( IDC_MSX1COLOR	, onSetMSX1		);		// MSX1F
	ONEVENT( IDC_SAVEPLT	, onSetSavePlt	);		// گĕۑ
	// `FbN{bNX
	ONEVENT( IDC_INTER		, onSetInter	);		// C^[[X
	ONEVENT( IDC_PAL		, onSetPal		);		// Œpbg
	ONEVENT( IDC_SELCOL		, onSetSelCol	);		// IF[h
	ONEVENT( IDC_AUTONAME	, onSetAutoName	);		// t@C
	ONEVENT( IDC_JKRC		, onSetJKrc		);		// F̍ČvZ
	ONEVENT( IDC_GOSA		, onSetGosa		);		// 덷gU
	ONEVENT( IDC_CHKZERO	, onSetNonZero	);		// OԂgȂ
	ONEVENT( IDC_TILE		, onSetTile		);		// Ԃ^C
	ONEVENT( IDC_CHKDEF		, onSetChkDef	);		// ̫Ăֺ߰
	ONEVENT( IDC_192		, onSet192		);		// 192Co
	ONEVENT( IDC_RESIZE		, onSetResize	);		// ޒ
	// R{{bNX
	ONEVENT( IDC_RESAMPLE	, onSetResample	);		// ޒػ
	ONEVENT( IDC_CMBSCREEN	, onSetMode		);		// Screen5
	ONEVENT( IDC_CMBPLT		, onSetPltMode	);		// pbg[h
	ONEVENT( IDC_CMBALGO	, onSetAlgo		);		// R搶ASY
	ONEVENT( IDC_CMBERR		, onSetErr		);		// fBUp^[
	ONEVENT( IDC_PREVIEW	, onSetPreView	);		// o͐
	ONEVENT( IDC_SEIDO		, onSetSeido	);		// x
	ONEVENT( IDC_CMBERR2	, onSetErrAdd	);		// fBUZ@
	ONEVENT( IDC_PALEN		, onSetPalEnable);		// pbggpE
	ONEVENT( IDC_FZERO		, onSetFZero	);		// ۉ
	ONEVENT( IDC_SORT		, onSetSort		);		// \[g
	ONEVENT( IDC_CMBCNV		, onSetCmbCnv	);		// ϊݒ
	ONEVENT( IDC_SIZEMODE	, onSetSizeMode	);		// TCYTCY[h
	}
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		J[pbgŉENbN
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onColRButtonDown )
{
	POINT	pos;
	int		col;
	HWND	hPWnd;

	// _CAÕnh
	hPWnd = GetParent( hWnd );

	// }EXJ[\̈ʒu𓾂
	pos.x = GET_X_LPARAM( lp );
	pos.y = GET_Y_LPARAM( lp );

	// w肵ĂFԍ𓾂
	col = (((pos.x*8)/w) & 7) + (((pos.y*2)/h) & 1)*8;

	// pbg̗LݒύX
	EdtMode.PalEn[ col ] = ( EdtMode.PalEn[ col ] + 1 ) % ELMCNT( PalEnName );
	SetEditColor( hPWnd, col, true );

	InvalidateRect( hWnd,NULL,FALSE );

	return 0;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		J[pbgōNbN
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onColLButtonDown )
{
	POINT	pos;
	int		c;

	// }EXJ[\̈ʒu𓾂
	pos.x = GET_X_LPARAM( lp );
	pos.y = GET_Y_LPARAM( lp );

	// w肵ĂFԍ𓾂
	c = (( ( pos.x * 8 ) / w ) & 7 ) + (( ( pos.y * 2 ) / h ) & 1 ) * 8;
	if( (EdtMode.Mode == MD_SC6 || EdtMode.Mode == MD_SC6_256L) && (c > 3) ) return 0;
	SetEditColor( GetParent( hWnd ), c, true );
	InvalidateRect( hWnd, NULL, FALSE );

	//	}EXL
	SetCapture( hWnd );
	bDraging = true;

	return 0;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		J[pbg̍ĕ`
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onColPaint )
{
	HDC			hDC;
	PAINTSTRUCT	ps;

	hDC = BeginPaint( hWnd,&ps );

	BitBlt( hDC, 0, 0, w, h, hMemDC, 0, 0, SRCCOPY );

	EndPaint( hWnd,&ps );

	return 0;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		J[pbgō{^𗣂
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onColLButtonUp )
{
	POINT	pos;
	int		p;

	if( !bDraging ) goto skip;
	//	}EX
	ReleaseCapture();
	bDraging = false;

	// }EXJ[\̈ʒu𓾂
	pos.x = GET_X_LPARAM( lp );
	pos.y = GET_Y_LPARAM( lp );

	//	͈͓
	if( pos.x < 0 || pos.y < 0 || pos.x >= w || pos.y >= h ) goto skip;

	// IFƃJ[\ʒu̐Fւ
	p = (( ( pos.x * 8 ) / w ) & 7 ) + (( ( pos.y * 2 ) / h ) & 1 ) * 8;
	if( p < 0 || p > 15 ) goto skip;
	if( (EdtMode.Mode == MD_SC6 || EdtMode.Mode == MD_SC6_256L) && (p > 3) ) goto skip;
	ChangeColor( NowCol, p );

	//	I̍XV
	SetEditColor( hWnd, p,true );
	InvalidateRect( hWnd, NULL, FALSE );
skip:
	return 0;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		J[pbgŃJ[\ړ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		J[\̌`ς
// -------------------------------------------------------------
EVENT( onColMouseMove )
{
	if( bDraging ) {
		SetCursor( LoadCursor( hIns, MAKEINTRESOURCE( IDC_CHGPAL ) ) );
	} else {
		SetCursor( LoadCursor( NULL, IDC_ARROW ) );
	}

	return 0;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		[̍ĕ`
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onFZPaint )
{
	HDC			hDC;
	PAINTSTRUCT	ps;
	RECT		r;
	HBRUSH		hBr;

	hDC = BeginPaint( hWnd,&ps );

	GetClientRect( hWnd, &r );
	hBr = CreateSolidBrush( EdtMode.FZColor );
	if( hBr != NULL ) {
		FillRect( hDC, &r, hBr );
		DeleteBrush( hBr );
	}

	EndPaint( hWnd,&ps );

	return 0;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		wiF̍ĕ`
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onFCPaint )
{
	HDC			hDC;
	PAINTSTRUCT	ps;
	RECT		r;
	HBRUSH		hBr;

	hDC = BeginPaint( hWnd,&ps );

	GetClientRect( hWnd, &r );
	hBr = CreateSolidBrush( EdtMode.FCColor );
	if( hBr != NULL ) {
		FillRect( hDC, &r, hBr );
		DeleteBrush( hBr );
	}

	EndPaint( hWnd,&ps );

	return 0;
}

// -------------------------------------------------------------
// eLXg{bNX

// -------------------------------------------------------------
//	1.	{ꖼ
//		[@wW
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetFZX )
{
	EdtMode.FZX = 0;
	EdtMode.FZX = GetDlgItemInt( hWnd,IDC_FZ_X,NULL,FALSE );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		[@xW
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetFZY )
{
	EdtMode.FZY = 0;
	EdtMode.FZY = GetDlgItemInt( hWnd,IDC_FZ_Y,NULL,FALSE );
	return TRUE;
}

// -------------------------------------------------------------
// {^Cxg

// -------------------------------------------------------------
//	1.	{ꖼ
//		{^FɃftHgփRs[
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetOk )
{
	if( EdtMode.Mode == MD_SC2 || EdtMode.Mode == MD_SC3 ) {
		EdtMode.Inter = false;
	}

	if( NowMode.bDefault ) {
		CALLEVENT( onSetDefault );
	}

	_enddlg( hWnd,0 );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ۉ̐FwCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetFZColor )
{
	CHOOSECOLOR	cc;
	// FI_CAO̐ݒ
	memset( &cc, 0, sizeof( cc ) );
	cc.lStructSize	= sizeof( cc );
	cc.hwndOwner	= hWnd;
	cc.lpCustColors	= CustColors;
	cc.Flags		= CC_FULLOPEN | CC_RGBINIT;
	cc.rgbResult	= EdtMode.FZColor;
	if( !ChooseColor( &cc ) ) return TRUE;
	EdtMode.FZColor	= cc.rgbResult;
	InvalidateRect( hWnd, NULL, FALSE );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ۉ̐FwCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetFCColor )
{
	CHOOSECOLOR	cc;
	// FI_CAO̐ݒ
	memset( &cc, 0, sizeof( cc ) );
	cc.lStructSize	= sizeof( cc );
	cc.hwndOwner	= hWnd;
	cc.lpCustColors	= CustColors;
	cc.Flags		= CC_FULLOPEN | CC_RGBINIT;
	cc.rgbResult	= EdtMode.FCColor;
	if( !ChooseColor( &cc ) ) return TRUE;
	EdtMode.FCColor	= cc.rgbResult;
	InvalidateRect( hWnd, NULL, FALSE );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		SēCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetEnRevs		)
{
	int i, j;

	if( EdtMode.Mode == MD_SC6 || EdtMode.Mode == MD_SC6_256L ) {
		j = 4;
	} else {
		j = 16;
	}

	for( i = 0; i < j; ++i ){
		EdtMode.PalEn[ i ] = EdtMode.PalEn[ NowCol ];
		UpdateColor( i );
	}
	InvalidateRect( hWnd, NULL, FALSE );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		گēǂݍ݃Cxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetLoadPlt )
{
	char			szFileName[ MAX_PATH ];
	OPENFILENAME	ofn;
	int				i;
	// t@C
	szFileName[ 0 ] = '\0';
	ZeroMemory( &ofn, sizeof( ofn ) );
	ofn.lStructSize		= sizeof( ofn );
	ofn.hInstance		= hIns;
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= cszDefPLL;
	ofn.lpstrCustomFilter= NULL;
	ofn.nFilterIndex	= 1;
	ofn.Flags			= OFN_LONGNAMES | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR | OFN_EXPLORER;
	ofn.lpstrFile		= szFileName;
	ofn.nMaxFile		= MAX_PATH;
	ofn.lpstrFileTitle	= NULL;
	ofn.lpstrInitialDir	= NULL;	// Jg
	ofn.lpstrTitle		= PLLoad;
	if( !GetOpenFileName( &ofn ) ) return TRUE;
	// ǂݍ
	i = strlen( szFileName );
	if( (i > 4) && ( toupper(szFileName[ i-3 ]) == 'P' ) ) {	//	*.P?? ǂ
		LoadPLFile( szFileName );
	} else {
		bsvLoadPLBsaveFile( &EdtMode, szFileName );
	}
	// ʂ̍XV
	for( i = 0; i < 16; ++i ){
		UpdateColor( i );
	}
	SetEditColor( hWnd, NowCol, true );
	InvalidateRect( hWnd, NULL, FALSE );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		گĕۑCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetSavePlt )
{
	char			szFileName[ MAX_PATH ];
	OPENFILENAME	ofn;
	// t@C
	szFileName[ 0 ] = '\0';
	ZeroMemory( &ofn, sizeof( ofn ) );
	ofn.lStructSize		= sizeof( ofn );
	ofn.hInstance		= hIns;
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= cszDefPL;
	ofn.lpstrCustomFilter= NULL;
	ofn.nFilterIndex	= 1;
	ofn.Flags			= OFN_LONGNAMES | OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_OVERWRITEPROMPT | OFN_EXPLORER;
	ofn.lpstrFile		= szFileName;
	ofn.nMaxFile		= MAX_PATH;
	ofn.lpstrFileTitle	= NULL;
	ofn.lpstrInitialDir	= NULL;	// Jg
	ofn.lpstrTitle		= PLSave;
	if( !GetSaveFileName( &ofn ) ) return TRUE;
	// ǂݍ
	bsvSavePLFile( hWnd, szFileName, &EdtMode );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ݒۑCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetSaveAs )
{
	char szFileName[ MAX_PATH ];
	// ̧ٖ
	if( !GetName( hWnd, szFileName, MAX_PATH, NULL, cszDefCfg, CfgExt ) ) return TRUE;
	// ۑ
	SaveCfgFile( &EdtMode, szFileName );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ݒ̓ǂݏoCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetLoad )
{
	char szFileName[ MAX_PATH ];
	OPENFILENAME	ofn;
	// t@CJ
	szFileName[0]='\0';
	ZeroMemory( &ofn, sizeof( ofn ) );
	ofn.lStructSize		= sizeof( ofn );
	ofn.hInstance		= hIns;
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= cszDefCfg;
	ofn.lpstrCustomFilter= NULL;
	ofn.nFilterIndex	= 1;
	ofn.Flags			= OFN_LONGNAMES | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;
	ofn.lpstrFile		= szFileName;
	ofn.nMaxFile		= MAX_PATH;
	ofn.lpstrFileTitle	= NULL;
	ofn.lpstrInitialDir	= NULL;	// Jg
	ofn.lpstrTitle		= cOpenFile;
	if( !GetOpenFileName( &ofn ) ) return TRUE;
	// ݒ𔽉f
	GetCfgFile( &EdtMode, szFileName );
	// ʂ̍XV
	UpdateAll( hWnd );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		̫Ăֺ߰
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetDefault )
{
	bool	bDefault;

	//	ĕϊ̎̂ݏ
	if( !bRedo ) return TRUE;

	bDefault = NowMode.bDefault;
	NowMode = EdtMode;
	NowMode.bDefault = bDefault;
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		lrwPF
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetMSX1 )
{
	SetDefPalette( EdtMode.Col );
	UpdateAll( hWnd );
	return TRUE;
}

// -------------------------------------------------------------
// `FbN{bNX

// -------------------------------------------------------------
//	1.	{ꖼ
//		OԂgȂ`FbNCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetNonZero )
{
	EdtMode.NonZero = !EdtMode.NonZero;
	UpdateColor( 0 );
	InvalidateRect( hWnd, NULL, FALSE );
	return TRUE;
}


// -------------------------------------------------------------
//	1.	{ꖼ
//		덷gU`FbNCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetGosa )
{
	EdtMode.Gosa = !EdtMode.Gosa;
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		덷gU`FbNCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetPalEnable )
{
	EdtMode.PalEn[ NowCol ] = ComboBox_GetCurSel( GetDlgItem( hWnd, IDC_PALEN ) );
	UpdateColor( NowCol );
	InvalidateRect( hWnd, NULL, FALSE );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		C^[[X`FbNCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetInter )
{
	EdtMode.Inter = !EdtMode.Inter;
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@C`FbNCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetAutoName )
{
	EdtMode.AutoName = !EdtMode.AutoName;
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		FČvZ`FbNCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetJKrc )
{
	EdtMode.JKrc = !EdtMode.JKrc;
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		SŒpbg`FbNCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetPal )
{
	int i;
	EdtMode.Pal = !EdtMode.Pal;
	for( i=0; i<16; ++i ){
		UpdateColor( i );
	}
	InvalidateRect( hWnd,NULL,FALSE );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		IF[h`FbNCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetSelCol )
{
	EdtMode.SelCol = !EdtMode.SelCol;
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		Ԃ^C`FbNCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetTile )
{
	EdtMode.Tile = !EdtMode.Tile;
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ɃftHg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetChkDef )
{
	EdtMode.bDefault = !EdtMode.bDefault;
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		192C[h
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSet192 )
{
	EdtMode.b192 = !EdtMode.b192;
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		TCY߃Cxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetResize )
{
	EdtMode.Resize = !EdtMode.Resize;
	SetCtlEnable( hWnd );
	return TRUE;
}

// -------------------------------------------------------------
// XC_

// -------------------------------------------------------------
//	1.	{ꖼ
//		XC_Cxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetHScroll )
{
	HWND	hCol = (HWND)lp;
	int		pos  = SendMessage( hCol, TBM_GETPOS, 0, 0 );
	char	szBuf[32];

	switch( GetDlgCtrlID( hCol ) )
	{
	case IDC_GOSAVAL:	// 덷gUW
		EdtMode.Gosaval = float( pos ) / 1000;
		wsprintf( szBuf, "0.%03d", pos );
		SetDlgItemText( hWnd, IDC_GOSAVALS, szBuf );
		return TRUE;
	case IDC_GOSAERR:	// 덷؂̂Ēl
		EdtMode.err = pos;
		wsprintf( szBuf, "%d", pos );
		SetDlgItemText( hWnd, IDC_GOSAERRS, szBuf );
		return TRUE;
	case IDC_RED:		// 
		EdtMode.Col[ NowCol ].red   = pos;
		break;
	case IDC_GREEN:		// 
		EdtMode.Col[ NowCol ].green = pos;
		break;
	case IDC_BLUE:		// 
		EdtMode.Col[ NowCol ].blue  = pos;
		break;
	default:
		return FALSE;
	}
	SetEditColor( hWnd, NowCol, false );
	InvalidateRect( hWnd, NULL, FALSE );
	return TRUE;
}

// -------------------------------------------------------------
// R{{bNX

// -------------------------------------------------------------
//	1.	{ꖼ
//		TCY߃TvCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetResample )
{
	EdtMode.Resample = ComboBox_GetCurSel( GetDlgItem( hWnd, IDC_RESAMPLE ) );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		TCY߃TCY[h
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetSizeMode )
{
	EdtMode.SizeMode = ComboBox_GetCurSel( GetDlgItem( hWnd, IDC_SIZEMODE ) );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		[hݒR{{bNXCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetFZero )
{
	EdtMode.FourceZero = ComboBox_GetCurSel( GetDlgItem( hWnd, IDC_FZERO ) );
	// Rg[ ON/OFF
	SetCtlEnable( hWnd );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		[hݒR{{bNXCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetMode )
{
	if( HIWORD( wp ) != CBN_SELCHANGE ) return TRUE;
	EdtMode.Mode = ComboBox_GetCurSel( GetDlgItem( hWnd, IDC_CMBSCREEN ) );
	// Rg[ ON/OFF
	SetCtlEnable( hWnd );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		R搶ASYCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetAlgo )
{
	EdtMode.AlgoMode = ComboBox_GetCurSel( GetDlgItem( hWnd, IDC_CMBALGO ) );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		fBUp^[Cxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetErr )
{
	EdtMode.ErrAlgo = ComboBox_GetCurSel( GetDlgItem( hWnd,IDC_CMBERR ) );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		fBUZ@Cxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetErrAdd )
{
	EdtMode.ErrAdd = ComboBox_GetCurSel( GetDlgItem( hWnd, IDC_CMBERR2 ) );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		o͐Cxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetPreView )
{
	EdtMode.PreView = ComboBox_GetCurSel( GetDlgItem( hWnd, IDC_PREVIEW ) ) + 1;
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		xCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetSeido )
{
	EdtMode.Seido = ComboBox_GetCurSel( GetDlgItem( hWnd, IDC_SEIDO ) );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		pbg[hCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetPltMode )
{
	EdtMode.PltMode = ComboBox_GetCurSel( GetDlgItem( hWnd,IDC_CMBPLT ) );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		\[g[hCxg
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetSort )
{
	EdtMode.SortMode = ComboBox_GetCurSel( GetDlgItem( hWnd,IDC_SORT ) );
	return TRUE;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ϊݒ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		TRUE
//	4.	l
//		Ȃ
// -------------------------------------------------------------
EVENT( onSetCmbCnv )
{
	EdtMode.CnvMode = ComboBox_GetCurSel( GetDlgItem( hWnd, IDC_CMBCNV ) );
	return TRUE;
}

// -------------------------------------------------------------
// [eBeB

// -------------------------------------------------------------
//	1.	{ꖼ
//		ʂXV
//	2.	
//		hWnd	..	(I)	_CAÕnh
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void UpdateAll( HWND hWnd )
{
	int		i;
	char	szBuf[ 32 ];
	// J[e[u`悷
	for( i = 0; i < 16; i++ ) UpdateColor( i );
	// o̓[h
	Button_SetCheck( GetDlgItem( hWnd, IDC_GOSA		), EdtMode.Gosa		? BST_CHECKED : BST_UNCHECKED );
	Button_SetCheck( GetDlgItem( hWnd, IDC_INTER	), EdtMode.Inter	? BST_CHECKED : BST_UNCHECKED );
	Button_SetCheck( GetDlgItem( hWnd, IDC_PAL		), EdtMode.Pal		? BST_CHECKED : BST_UNCHECKED );
	Button_SetCheck( GetDlgItem( hWnd, IDC_SELCOL	), EdtMode.SelCol	? BST_CHECKED : BST_UNCHECKED );
	Button_SetCheck( GetDlgItem( hWnd, IDC_RESIZE	), EdtMode.Resize	? BST_CHECKED : BST_UNCHECKED );
	Button_SetCheck( GetDlgItem( hWnd, IDC_AUTONAME	), EdtMode.AutoName	? BST_CHECKED : BST_UNCHECKED );
	Button_SetCheck( GetDlgItem( hWnd, IDC_JKRC		), EdtMode.JKrc		? BST_CHECKED : BST_UNCHECKED );
	Button_SetCheck( GetDlgItem( hWnd, IDC_CHKZERO	), EdtMode.NonZero	? BST_CHECKED : BST_UNCHECKED );
	Button_SetCheck( GetDlgItem( hWnd, IDC_TILE		), EdtMode.Tile		? BST_CHECKED : BST_UNCHECKED );
	Button_SetCheck( GetDlgItem( hWnd, IDC_CHKDEF	), EdtMode.bDefault	? BST_CHECKED : BST_UNCHECKED );
	Button_SetCheck( GetDlgItem( hWnd, IDC_192		), EdtMode.b192		? BST_CHECKED : BST_UNCHECKED );
	// XC_͈̔͂ݒ
	SetSliderRange( GetDlgItem( hWnd, IDC_GOSAVAL ), 1, 500 );
	SetSliderRange( GetDlgItem( hWnd, IDC_GOSAERR ), 0, 255 );
	SetSliderRange( GetDlgItem( hWnd, IDC_RED     ), 0, 7   );
	SetSliderRange( GetDlgItem( hWnd, IDC_GREEN   ), 0, 7   );
	SetSliderRange( GetDlgItem( hWnd, IDC_BLUE    ), 0, 7   );
	// XC_̈ʒu𒲐
	SetSliderValue( GetDlgItem( hWnd, IDC_GOSAVAL ), (short int)(EdtMode.Gosaval * 1000) );
	SetSliderValue( GetDlgItem( hWnd, IDC_GOSAERR ), (short int)(EdtMode.err) );
	wsprintf( szBuf, "0.%03d", int(EdtMode.Gosaval * 1000) );
	SetDlgItemText( hWnd, IDC_GOSAVALS, szBuf );
	wsprintf( szBuf, "%d", EdtMode.err );
	SetDlgItemText( hWnd, IDC_GOSAERRS, szBuf );
	SetEditColor( hWnd, 0, true );
	InvalidateRect( hWnd, NULL, FALSE );
	// R{{bNX
	ComboBox_Init( hWnd, IDC_CMBSCREEN	,ScrModeName,	ELMCNT( ScrModeName ),	EdtMode.Mode );
	ComboBox_Init( hWnd, IDC_CMBPLT		,PltMode,		PLT_COUNT,				EdtMode.PltMode );
	ComboBox_Init( hWnd, IDC_CMBALGO	,AlgoName,		ELMCNT( AlgoName ),		EdtMode.AlgoMode );
	ComboBox_Init( hWnd, IDC_CMBERR		,ErrAlgoName,	ELMCNT( ErrAlgoName ),	EdtMode.ErrAlgo );
	ComboBox_Init( hWnd, IDC_PREVIEW	,PreViewName,	ELMCNT( PreViewName ),	EdtMode.PreView - 1 );
	ComboBox_Init( hWnd, IDC_SEIDO		,ColorSeido,	ELMCNT( ColorSeido ),	EdtMode.Seido );
	ComboBox_Init( hWnd, IDC_CMBERR2	,ErrAlgo2Name,	ELMCNT( ErrAlgo2Name ),	EdtMode.ErrAdd );
	ComboBox_Init( hWnd, IDC_PALEN		,PalEnName,		ELMCNT( PalEnName ),	EdtMode.PalEn[ NowCol ] );
	ComboBox_Init( hWnd, IDC_FZERO		,FZColorName,	ELMCNT( FZColorName ),	EdtMode.FourceZero );
	ComboBox_Init( hWnd, IDC_SORT		,SortMode,		ELMCNT( SortMode ),		EdtMode.SortMode );
	ComboBox_Init( hWnd, IDC_CMBCNV		,UseSetting,	ELMCNT( UseSetting ),	EdtMode.CnvMode );
	ComboBox_Init( hWnd, IDC_RESAMPLE	,Resample,		ELMCNT( Resample ),		EdtMode.Resample );
	ComboBox_Init( hWnd, IDC_SIZEMODE	,SizeMode,		ELMCNT( SizeMode ),		EdtMode.SizeMode );
	// eLXg{bNX
	SetDlgItemInt( hWnd, IDC_FZ_X, EdtMode.FZX, FALSE );
	SetDlgItemInt( hWnd, IDC_FZ_Y, EdtMode.FZY, FALSE );
	// Rg[ ON/OFF
	SetCtlEnable( hWnd );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		J[e[u̐FXV
//	2.	
//		c	...	(I)	XVFԍ
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void UpdateColor( int c )
{
	RECT	r;
	HBRUSH	hBr;
	HPEN	hOld, hPen1, hPen2;
	bool	bDisable;

	//	SCREEN 6 ΍
	bDisable = ((EdtMode.Mode == MD_SC6 || EdtMode.Mode == MD_SC6_256L) && c > 3);

	r.left		= w * (  c & 7 )	   / 8;
	r.right		= w * (( c & 7 ) + 1 ) / 8;
	if( c & 8 ){
		r.top		= h / 2;
		r.bottom	= h;
	}else{
		r.top		= 0;
		r.bottom	= h / 2;
	}
	if( bDisable ) {
		hBr = CreateSolidBrush( GetSysColor( COLOR_APPWORKSPACE ) );
	} else {
		hBr = CreateSolidBrush( RGB( cc[ EdtMode.Col[ c ].red   ],
									 cc[ EdtMode.Col[ c ].green ],
									 cc[ EdtMode.Col[ c ].blue  ] ) );
	}
	FillRect( hMemDC, &r, hBr );
	DeleteBrush( hBr );
	if( !bDisable ) {
		hPen1 = CreatePen( PS_SOLID, 0, COLCUR1 );
		hPen2 = CreatePen( PS_SOLID, 0, COLCUR2 );
		if( EdtMode.PalEn[ c ] == PALEN_NONE || ( c == 0 && EdtMode.NonZero ) ){
			// gp̏ꍇ͎ΐ
			DrawIcon( hMemDC, r.left, r.top, LoadIcon( wu_get_instance(), MAKEINTRESOURCE(IDI_NOUSE) ) );
		}
		if( EdtMode.PalEn[ c ] == PALEN_USE || EdtMode.Pal ){
			// ŒȂ牡
			DrawIcon( hMemDC, r.left, r.top, LoadIcon( wu_get_instance(), MAKEINTRESOURCE(IDI_HOLD) ) );
		}
		if( c == NowCol ){
			// ݂̒ړ_Ȃ֊s̕\
			hOld = SelectPen( hMemDC, hPen1 );
			Rectangle( hMemDC, r.left + 1, r.top + 1, r.right - 1, r.bottom - 1 );
			SelectPen( hMemDC, hPen2 );
			Rectangle( hMemDC, r.left, r.top, r.right, r.bottom );
			SelectPen( hMemDC, hOld );
		}
		DeletePen( hPen2 );
		DeletePen( hPen1 );
	}
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		Q̃pbg̓e
//	2.	
//		p1		...	(I)	pbgԍP
//		p2		...	(I)	pbgԍQ
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void ChangeColor( int p1, int p2 )
{
	int	t;

	//	SCREEN6 ΍
	if( (EdtMode.Mode == MD_SC6 || EdtMode.Mode == MD_SC6_256L) && ((p1 > 3) || (p2 > 3)) ) return;

	//	pbgľ
	t = EdtMode.Col[ p1 ].red;		EdtMode.Col[ p1 ].red	= EdtMode.Col[ p2 ].red;	EdtMode.Col[ p2 ].red	= t;
	t = EdtMode.Col[ p1 ].green;	EdtMode.Col[ p1 ].green	= EdtMode.Col[ p2 ].green;	EdtMode.Col[ p2 ].green	= t;
	t = EdtMode.Col[ p1 ].blue;		EdtMode.Col[ p1 ].blue	= EdtMode.Col[ p2 ].blue;	EdtMode.Col[ p2 ].blue	= t;

	//	Ԃ̌
	t = EdtMode.PalEn[ p1 ];		EdtMode.PalEn[ p1 ]		= EdtMode.PalEn[ p2 ];		EdtMode.PalEn[ p2 ]		= t;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ҏWFύX
//	2.	
//		hWnd	...	(I)	_CAOnh
//		c		...	(I)	ҏWF
//		s		...	(I)	XC_XV邩ۂ
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void SetEditColor( HWND hWnd, int c, bool s )
{
	char szBuf[ 32 ];
	int back;
	back	= NowCol;
	if( (EdtMode.Mode == MD_SC6 || EdtMode.Mode == MD_SC6_256L) && c > 3) return;
	NowCol	= c;
	UpdateColor( back );
	if( s ){
		SetSliderValue( GetDlgItem( hWnd,IDC_RED     ),EdtMode.Col[c].red   );
		SetSliderValue( GetDlgItem( hWnd,IDC_GREEN   ),EdtMode.Col[c].green );
		SetSliderValue( GetDlgItem( hWnd,IDC_BLUE    ),EdtMode.Col[c].blue  );
	}
	wsprintf( szBuf, "COLOR=%d", c );
	SetDlgItemText( hWnd, IDC_COL	, szBuf );
	wsprintf( szBuf, "R=%d", EdtMode.Col[ c ].red   );
	SetDlgItemText( hWnd, IDC_NRED	, szBuf );
	wsprintf( szBuf, "G=%d", EdtMode.Col[ c ].green );
	SetDlgItemText( hWnd, IDC_NGREEN, szBuf );
	wsprintf( szBuf, "B=%d", EdtMode.Col[ c ].blue  );
	SetDlgItemText( hWnd, IDC_NBLUE	, szBuf );
	UpdateColor( NowCol );
	ComboBox_SetCurSel( GetDlgItem( hWnd, IDC_PALEN	), EdtMode.PalEn[ NowCol ] );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//	XC_igbNo[j̍őlƍŏlݒ肷
//	2.	
//		max	...	(I)	ől
//		min	...	(I)	ŏl
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static inline void SetSliderRange( HWND hWnd, short int max, short int min )
{
	SendMessage( hWnd, TBM_SETRANGE, TRUE, MAKELONG( max, min ) );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		XC_igbNo[j̈ʒuύX
//	2.	
//		val	...	(I)	ʒu
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static inline void SetSliderValue( HWND hWnd, short int val )
{
	SendMessage( hWnd, TBM_SETPOS, TRUE, (LONG)val );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		PL? `̃pbgǂݍ
//	2.	
//		szFileName	...	(I)	t@C
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void LoadPLFile( const char *szFileName )
{
	FU_FILE	*hFile;
	BYTE	Buf[ 32 ];
	char	szBuf[ MAX_PATH + 256 ];
	int		i;

	// t@CJ
	hFile = fu_open( szFileName, "rb" );
	if( hFile == FU_INVALID_HANDLE ){
#ifdef _ENGLISH
		wsprintf( szBuf,"Read error (%s)",szFileName );
#else
		wsprintf( szBuf,"%s ̓ǂݍ݂Ɏs܂B",szFileName );
#endif
		MessageBox( NULL, szBuf, MsgCap, MB_OK | MB_ICONWARNING );
		return;		// t@CJȂ
	}
	// f[^͂
	memset( Buf, 0,sizeof( Buf ) );
	fu_read( hFile, Buf, sizeof( Buf ) );
	// ̓f[^𔽉f
	for( i = 0; i < 16; ++i ){
		EdtMode.Col[ i ].red  = (Buf[ i * 2 + 0 ] >> 4 ) & 0x07;
		EdtMode.Col[ i ].blue =  Buf[ i * 2 + 0 ]        & 0x07;
		EdtMode.Col[ i ].green=  Buf[ i * 2 + 1 ]        & 0x07;
	}
	// I
	fu_close( hFile );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		[hɍ킹eRg[ ON/OFF
//	2.	
//		hWnd	...	(I)	EBhEnh
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void SetCtlEnable( HWND hWnd )
{
	int i;
	//	ʂ̃Rg[
	for( i = 0; i < ELMCNT( nCtrlCode ); ++i ){
		EnableWindow( GetDlgItem( hWnd,nCtrlCode[ i ] ), nCtrlEnbl[ EdtMode.Mode ][ i ] );
	}
	// ۉ
	if( EdtMode.Mode < MD_SC10 || (EdtMode.Mode >= MD_SC5_256L && EdtMode.Mode < MD_SC10_256L) ) {
		EnableWindow( GetDlgItem( hWnd, IDC_FZERO ), TRUE );
		switch( EdtMode.FourceZero ){
		case FZ_NONE:
			EnableWindow( GetDlgItem( hWnd, IDC_FZCOLOR	), FALSE );
			EnableWindow( GetDlgItem( hWnd, IDC_FZ_X	), FALSE );
			EnableWindow( GetDlgItem( hWnd, IDC_FZ_Y	), FALSE );
			break;
		case FZ_COLOR:
			EnableWindow( GetDlgItem( hWnd, IDC_FZCOLOR	), TRUE  );
			EnableWindow( GetDlgItem( hWnd, IDC_FZ_X	), FALSE );
			EnableWindow( GetDlgItem( hWnd, IDC_FZ_Y	), FALSE );
			break;
		case FZ_MATRIX:
			EnableWindow( GetDlgItem( hWnd, IDC_FZCOLOR	), FALSE );
			EnableWindow( GetDlgItem( hWnd, IDC_FZ_X	), TRUE  );
			EnableWindow( GetDlgItem( hWnd, IDC_FZ_Y	), TRUE  );
			break;
		}
	}else{
		EnableWindow( GetDlgItem( hWnd, IDC_FZERO	), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDC_FZCOLOR	), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDC_FZ_X	), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDC_FZ_Y	), FALSE );
	}
	//	pbg\
	if( (EdtMode.Mode == MD_SC6 || EdtMode.Mode == MD_SC6_256L) && (NowCol > 3) ) {
		SetEditColor( hWnd, 3, true );
	}
	if( EdtMode.Mode < MD_SC8 || (EdtMode.Mode >= MD_SC5_256L && EdtMode.Mode < MD_SC8_256L) ) {
		for( i = 0; i < 16; ++i ){
			UpdateColor( i );
		}
		InvalidateRect( hWnd, NULL, FALSE );
		ShowWindow( GetDlgItem( hWnd, IDC_COLTBL ), SW_SHOW );
	} else {
		ShowWindow( GetDlgItem( hWnd, IDC_COLTBL ), SW_HIDE );
	}
	//	ĕϊ̫Đݒ̈Ⴂ
	if( bRedo ) {
		EnableWindow( GetDlgItem( hWnd, IDC_DEFAULT ), EdtMode.bDefault ? FALSE : TRUE );
		ShowWindow( GetDlgItem( hWnd, IDC_DEFAULT ), SW_SHOW );
		ShowWindow( GetDlgItem( hWnd, IDC_CHKDEF  ), SW_HIDE );
		ShowWindow( GetDlgItem( hWnd, IDC_CMBCNV  ), SW_HIDE );
		ShowWindow( GetDlgItem( hWnd, IDC_LBLSSET ), SW_HIDE );
	} else {
		ShowWindow( GetDlgItem( hWnd, IDC_DEFAULT ), SW_HIDE );
		ShowWindow( GetDlgItem( hWnd, IDC_CHKDEF  ), SW_SHOW );
		ShowWindow( GetDlgItem( hWnd, IDC_CMBCNV  ), SW_SHOW );
		ShowWindow( GetDlgItem( hWnd, IDC_LBLSSET ), SW_SHOW );
	}
	//	TCY
	if( EdtMode.Resize ) {
		EnableWindow( GetDlgItem( hWnd, IDC_RESAMPLE ), TRUE );
		EnableWindow( GetDlgItem( hWnd, IDC_SIZEMODE ), TRUE );
	} else {
		EnableWindow( GetDlgItem( hWnd, IDC_RESAMPLE ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDC_SIZEMODE ), FALSE );
	}
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		R{{bNX̏
//	2.	
//		hWnd	...	(I)	EBhEnh
//		id		...	(I)	R{{bNX̂hc
//		sArray	...	(I)	z
//		n		...	(I)	z̗vf
//		index	...	(I)	R{{bNX̏CfbNX
// -------------------------------------------------------------
static void ComboBox_Init( HWND hWnd, int id, const char **sArray, int n, int index )
{
	HWND hCmb;
	int i;
	hCmb = GetDlgItem( hWnd,id );
	ComboBox_ResetContent( hCmb );
	for( i=0; i<n;++i ){
		ComboBox_AddString( hCmb,sArray[i] );
	}
	ComboBox_SetCurSel( hCmb,index );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		I
//	2.	
//		hWnd		...	(I)	EBhEnh
//		exitcode	...	(I)	_CAOIR[h
//	3.	Ԓl
//		Ȃ
//	4.	l
//		\[X̉sB
// -------------------------------------------------------------
static void _enddlg( HWND hWnd, int exitcode )
{
	// \[X̉
	if( hMemDC!=NULL ) DeleteDC( hMemDC );
	if( hMemBM!=NULL ) DeleteBitmap( hMemBM );
	hMemDC=NULL;
	hMemBM=NULL;
	// _CAȌI
	EndDialog( hWnd,exitcode );
}
