// -------------------------------------------------------------
// BMP to MSX
// e탆[eBeB
//												(C)2000 HRA!
// -------------------------------------------------------------

#include "utils.h"
#include "fileuty.h"

extern HINSTANCE hIns;

// ftHgpbgilrwdpbglj
static const PAL DefCol[]={
	{0,0,0},
	{0,0,0},
	{6,1,1},
	{7,3,3},
	{1,1,7},
	{3,2,7},
	{1,5,1},
	{6,2,7},
	{1,7,1},
	{3,7,3},
	{6,6,1},
	{6,6,4},
	{4,1,1},
	{2,6,5},
	{5,5,5},
	{7,7,7},
};

// =====================================================
// t@C֘A

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@C͂
//	2.	
//		szFileName	...	t@Ci[AhX
//		size		...	L̃TCY
//		szTitle		...	^Cg
//		szFilter	...	tB^
//		szExt		...	ftHggq
//	3.	Ԓl
//			OK = true
//			LZ = false
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool GetName( HWND hWnd,char *szFileName,int size,const char *szTitle,const char *szFilter, const char* szExt )
{
	OPENFILENAME	ofn;
	// t@C
	szFileName[0]='\0';
	ZeroMemory( &ofn,sizeof( ofn ) );
	ofn.lStructSize		= sizeof( ofn );
	ofn.hInstance		= hIns;
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= szFilter;
	ofn.lpstrCustomFilter= NULL;
	ofn.nFilterIndex	= 1;
	ofn.Flags			= OFN_LONGNAMES | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR;
	ofn.lpstrFile		= szFileName;
	ofn.nMaxFile		= size;
	ofn.lpstrFileTitle	= NULL;
	ofn.lpstrInitialDir	= NULL;	// Jg
	ofn.lpstrTitle		= szTitle;
	ofn.lpstrDefExt		= szExt;
	return( GetSaveFileName( &ofn )!=FALSE );
}

// =====================================================
// alot@C֘A

// -------------------------------------------------------------
//	1.	{ꖼ
//		BMPt@Cǂݍ
//	2.	
//			out		...	ǂݍ񂾃AhXi[ϐ̃AhX
//			ptr		...	[h̃|C^
//	3.	Ԓl
//			 true
//			s false
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool GetBmp( COLORREF **out,int *width,int *height,char **ptr )
{
	BITMAPINFOHEADER	bih;
	// CtHwb_ǂݍ
	memcpy( &bih,*ptr,sizeof( bih ) );
	*ptr += sizeof( bih );
	// t@C̎ނ𒲂ׂ
	if( bih.biCompression!=BI_RGB &&
		bih.biCompression!=BI_BITFIELDS ) return false;			// Ή`i񈳏kj
	*out = (COLORREF*)LocalAlloc( LMEM_FIXED,sizeof( COLORREF )*bih.biWidth * bih.biHeight + 1 );
	if( *out == NULL ) return false;							// mێs
	// TCY̎擾
	*width  = bih.biWidth;
	*height = bih.biHeight;
	// ϊ( BMPt@C`COLORREFz )
	switch( bih.biBitCount ){
	case 1:		//2Fpbg
		if( !GetBmp1(  &bih,ptr,*out ) ){
			goto _error_exit;
		}
		break;
	case 4:		//16Fpbg
		if( !GetBmp4(  &bih,ptr,*out ) ){
			goto _error_exit;
		}
		break;
	case 8:		//256Fpbg
		if( !GetBmp8(  &bih,ptr,*out ) ){
			goto _error_exit;
		}
		break;
	case 16:	// 16bitnCJ[
		if( !GetBmp16( &bih,ptr,*out ) ){
			goto _error_exit;
		}
		break;
	case 24:	// 24bittJ[
		if( !GetBmp24( &bih,ptr,*out ) ){
			goto _error_exit;
		}
		break;
	case 32:	// 24bit+8bittJ[
		if( !GetBmp32( &bih,ptr,*out ) ){
			goto _error_exit;
		}
		break;
	default:	// Ή̃rbg
		goto _error_exit;
	}
	return true;

	//	G[̏ꍇ
_error_exit:
	LocalFree(*out);
	*out=NULL;
	return false;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		1bit BMPt@Cǂݍŕϊ
//	2.	
//			bih		...	rbg}bvCtHwb_̃AhX
//			out		...	o͐惁̃AhX
//	3.	Ԓl
//			 true / s false
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool GetBmp1( BITMAPINFOHEADER *bih,char **ptr,COLORREF *pout )
{
	RGBQUAD		p[2];		// pbg
	int			i,w,x,y;	// GpAW
	BYTE		c;			// ǂݍ񂾃f[^
	BYTE		*pinp;		// ̓|C^
	// pbgǂݍ
	w=( (bih->biWidth+7)/8 +3) & 0xFFFFFFFC;
	if( !(bih->biClrUsed) ){ i=2; }else{ i=bih->biClrUsed; }
	memcpy( p,*ptr,sizeof( RGBQUAD )*i );
	*ptr += sizeof( RGBQUAD )*i;
	// ϊ
	for( y=bih->biHeight-1; y>=0 ; --y ){
		pinp = (BYTE*)( *ptr + y*w );
		for( x=0; x<bih->biWidth; ++x ){
			c = *pinp;
			c = (c >> ( 7-(x & 7) )) & 1;
			if( (x & 7)==7 ) ++pinp;
			*pout = RGB( p[c].rgbRed,p[c].rgbGreen,p[c].rgbBlue );
			++pout;
		}
	}
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		4bit BMPt@Cǂݍŕϊ
//	2.	
//			bih		...	rbg}bvCtHwb_̃AhX
//			out		...	o͐惁̃AhX
//	3.	Ԓl
//			 true
//			s false
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool GetBmp4( BITMAPINFOHEADER *bih,char **ptr,COLORREF *pout )
{
	RGBQUAD		p[16];		// pbg
	int			i,w,x,y;	// GpAW
	BYTE		c;			// ǂݍ񂾃f[^
	BYTE		*pinp;		// ̓|C^
	// pbgǂݍ
	w=( (bih->biWidth+1)/2 +3) & 0xFFFFFFFC;
	if( !(bih->biClrUsed) ){ i=16; }else{ i=bih->biClrUsed; }
	memcpy( p,*ptr,sizeof( RGBQUAD )*i );
	*ptr += sizeof( RGBQUAD )*i;
	// ̊m
	// ϊ
	for( y=bih->biHeight-1; y>=0; --y ){
		pinp = (BYTE*)( *ptr + y*w );
		for( x=0; x<bih->biWidth; ++x ){
			c = *pinp;
			if( x & 1 ){
				c = c & 0x0F;
				++pinp;
			}else{
				c =(c >> 4) & 0x0F;
			}
			*pout = RGB( p[c].rgbRed,p[c].rgbGreen,p[c].rgbBlue );
			++pout;
		}
	}
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		8bit BMPt@Cǂݍŕϊ
//	2.	
//			bih		...	rbg}bvCtHwb_̃AhX
//			pout	...	o͐惁̃AhX
//	3.	Ԓl
//			 true
//			s false
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool GetBmp8( BITMAPINFOHEADER *bih,char **ptr,COLORREF *pout )
{
	RGBQUAD	p[256];			// pbg
	int		i,w,x,y;		// GpAW
	BYTE	c;				// ǂݍ񂾃f[^
	BYTE	*pinp;			// ̓|C^
	// pbgǂݍ
	w=(bih->biWidth+3) & 0xFFFFFFFC;
	if( !(bih->biClrUsed) ){ i=256; }else{ i=bih->biClrUsed; }
	memcpy( p,*ptr,sizeof( RGBQUAD )*i );
	*ptr += sizeof( RGBQUAD )*i;
	// ϊ
	for( y=bih->biHeight-1; y>=0; --y ){
		pinp = (BYTE*)( *ptr + y*w );
		for( x=0; x<bih->biWidth; ++x ){
			c = *pinp;
			*pout = RGB( p[c].rgbRed,p[c].rgbGreen,p[c].rgbBlue );
			++pout;
			++pinp;
		}
	}
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		16bit BMPt@Cǂݍŕϊ
//	2.	
//			bih		...	rbg}bvCtHwb_̃AhX
//			pout	...	o͐惁̃AhX
//	3.	Ԓl
//			 true
//			s false
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool GetBmp16( BITMAPINFOHEADER *bih,char **ptr,COLORREF *pout )
{
	int		w,x,y;			// GpAW
	BYTE	r,g,b;			// qfa
	WORD	c;				// ǂݍ񂾃f[^
	BYTE	*pinp;			// ̓|C^
	// ͕
	w=(bih->biWidth*2+3) & 0xFFFFFFFC;
	// ϊ
	for( y=bih->biHeight-1; y>=0; --y ){
		pinp = (BYTE*)( *ptr + y*w );
		for( x=0; x<bih->biWidth; ++x ){
			c = (WORD)pinp[0]+((WORD)pinp[1]<<8);
			b = (c & 0x001F)     *255/31;
			g =((c & 0x07E0)>> 5)*255/63;
			r =((c & 0xF800)>>11)*255/31;
			*pout = RGB( r,g,b );
			pout++;
			pinp+=2;
		}
	}
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		24bit BMPt@Cǂݍŕϊ
//	2.	
//			bih		...	rbg}bvCtHwb_̃AhX
//			pout	...	o͐惁̃AhX
//	3.	Ԓl
//			 true
//			s false
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool GetBmp24( BITMAPINFOHEADER *bih,char **ptr,COLORREF *pout )
{
	int		w,x,y;			// GpAW
	BYTE	r,g,b;			// qfa
	BYTE	*pinp;			// ̓|C^
	// ͕
	w = (bih->biWidth*3+3) & 0xFFFFFFFC;
	// ϊ
	for( y=bih->biHeight-1; y>=0; --y ){
		pinp = (BYTE*)( *ptr + y*w );
		for( x=0; x<bih->biWidth; ++x ){
			b = pinp[0];
			g = pinp[1];
			r = pinp[2];
			pinp+=3;
			*pout = RGB( r,g,b );
			pout++;
		}
	}
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		32bit BMPt@Cǂݍŕϊ
//	2.	
//			bih		...	rbg}bvCtHwb_̃AhX
//			pout	...	o͐惁̃AhX
//	3.	Ԓl
//			 true
//			s false
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool GetBmp32( BITMAPINFOHEADER *bih,char **ptr,COLORREF *pout )
{
	int		w,x,y;			// GpAW
	BYTE	r,g,b;			// qfa
	BYTE	*pinp;			// ̓|C^
	// ͕
	w = bih->biWidth*4;
	// ϊ
	for( y=bih->biHeight-1; y>=0; --y ){
		pinp = (BYTE*)( *ptr + y*w );
		for( x=0; x<bih->biWidth; ++x ){
			b = pinp[0];
			g = pinp[1];
			r = pinp[2];
			pinp+=4;
			*pout = RGB( r,g,b );
			pout++;
		}
	}
	return true;
}

// =====================================================
// ݒ֘A

// -------------------------------------------------------------
//	1.	{ꖼ
//		pbglrwP̐Fɂ
//	2.	
//		pal	...	(O)	pbg̃AhX
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void SetDefPalette( PAL *pal )
{
	memcpy( pal, DefCol, sizeof(PAL)*16 );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ݒftHgɂ
//	2.	
//		Ȃ
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void GetDefCfg( SETTING *Mode )
{
	memset( Mode,0,sizeof( SETTING ) );
	memcpy( Mode->Col,DefCol,sizeof(PAL)*16 );
	Mode->Mode = MD_SC5;			// SCREEN5
	Mode->Gosaval = 0.43f;			// 덷gUW 0.430
	Mode->err = 0;					// ؂̂Č덷 0
	Mode->Gosa = true;				// 덷gU ON
	Mode->Pal = false;				// Œpbg gp
	Mode->Inter = false;			// C^[[X gp
	Mode->Resize = false;			// TCY gp
	Mode->SelCol = 0;				// FI[h
	Mode->PltMode = PLT_BSAVE;		// گďoӰ BSAVE Ɍ
	Mode->AutoName = true;			// t@C
	Mode->AlgoMode = ALGO_RECALC;	// R搶ASY
	Mode->JKrc = true;				// F̍ČvZ
	Mode->ErrAlgo = EALGO_DITH2;	// G[ASY
	Mode->PreView = 3;				// t@Cƃvr[ɏo
	Mode->Seido = SEIDO_24;			// 24bit x
	Mode->ErrAdd = EADD_ROTATE;		// fBUZ@ ]
	Mode->NonZero = false;			// OԂ̐Fg
	Mode->FourceZero = FZ_NONE;		// [Ȃ
	Mode->FZColor = 0;				// [F
	Mode->Tile = false;				// ^C
	Mode->bDefault = false;			// ɃftHgRs[
	Mode->CnvMode = CM_LAST;		// ŏIϊݒ̗p
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ݒǂݍ
//	2.	
//		Ȃ
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool GetCfgFile( SETTING *Mode,const char *sCfgFile )
{
	FU_FILE		*hFile;

	// ݒt@CJ
	GetDefCfg(Mode);	// t@C΃ftHgݒɂ
	hFile = fu_open( sCfgFile, "rb" );
	if( hFile == FU_INVALID_HANDLE ){
		return false;
	}
	// ݒǂݍ
	fu_read( hFile, Mode, sizeof( SETTING ) );
	fu_close( hFile );
	// sȒl
	Mode->PreView		= Mode->PreView & 3;
	if( Mode->PreView == 0 ) Mode->PreView = 1;
	Mode->ErrAlgo		= Mode->ErrAlgo % EALGO_MAX;
	Mode->AlgoMode		= Mode->AlgoMode % ALGO_MAX;
	Mode->SelCol		= Mode->SelCol % SELCOL_MAX;
	Mode->Mode			= Mode->Mode % MD_MAX;
	Mode->PltMode		= Mode->PltMode % PLT_MAX;
	Mode->Seido			= Mode->Seido % SEIDO_MAX;
	Mode->ErrAdd		= Mode->ErrAdd % EADD_MAX;
	Mode->FourceZero	= Mode->FourceZero % FZ_MAX;
	if( Mode->err > 255 ) Mode->err = 255;
	if( Mode->Gosaval < 0.0f ) Mode->Gosaval = 0.0f;
	if( Mode->Gosaval > 0.5f ) Mode->Gosaval = 0.5f;

	if( Mode->Mode == MD_SC2 || Mode->Mode == MD_SC3 ) {
		Mode->Inter = false;
	}

	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ݒۑ
//	2.	
//		Ȃ
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void SaveCfgFile( SETTING *Mode,const char *sCfgFile ) {
	FU_FILE		*hFile;

	// ݒt@CJ
	hFile = fu_open( sCfgFile, "wb" );
	if( hFile == FU_INVALID_HANDLE ) return;		// t@CȂΕۑȂ

	// ݒ
	fu_write( hFile, Mode, sizeof( SETTING ) );
	fu_close( hFile );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		pXǂݍ
//	2.	
//		sPathFile	...	(I)	pXf[^̓t@C
//		sPath		...	(I)	pXi[ϐ
//		len			...	(I)	R[h
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool GetPathFile( const char *sPathFile, char *sPath, int len ) {
	FU_FILE		*hFile;
	char		s_temp[ MAX_PATH ];
	char		s_path[ MAX_PATH ];
	char		*ptr;

	//	ftHg쐬
	strcpy( s_temp, GetCommandLine() );
	if( s_temp[ 0 ] == '\"' ) {
		strcpy( s_path, &s_temp[1] );
	} else {
		strcpy( s_path, s_temp );
	}
	ptr  = strrchr( s_path, '\\' );
	if( ptr != NULL ) ptr[1] = '\0';
	strcat( s_path, "plugin\\" );

	// pXt@CJ
	hFile = fu_open( sPathFile, "rb" );
	if( hFile == FU_INVALID_HANDLE ){
		strcpy( sPath, s_path );
		return false;
	}
	if( !fu_read( hFile, sPath, len ) ) {
		strcpy( sPath, s_path );
	}
	fu_close( hFile );
	
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		pXۑ
//	2.	
//		sPathFile	...	(I)	pXf[^i[t@C
//		sPath		...	(I)	pXi[Ăϐ
//		len			...	(I)	R[h
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void SavePathFile( const char *sPathFile, char *sPath, int len ) {
	FU_FILE		*hFile;

	// pXt@CJ
	hFile = fu_open( sPathFile, "wb" );
	if( hFile == FU_INVALID_HANDLE ){
		return;		// t@CȂΕۑȂ
	}
	// ݒ
	fu_write( hFile, sPath, len );
	fu_close( hFile );
}
