// -------------------------------------------------------------
//	TITLE	:	BMP to MSX vr[Ǘ֘A
//	INPUT	:	HRA!
// -------------------------------------------------------------

// =============================================================
//	CN[h

#include <windows.h>
#include <windowsx.h>

#include "config.h"
#include "convert.h"
#include "PreView.h"
#include "ProgProc.h"
#include "splug.h"
#include "fileuty.h"

// =============================================================
//	֐vg^Cv

static int _bdAddFile( const char *cszFileName );
static int WINAPI ProgressCallback( int nNum, int nDenom, long lData );

// =============================================================
//	ϐ

BMPDATA	tBmpview[ PV_MAX ];		// alot@C
PVDATA	tPreview[ PV_MAX ];		// vr[
int		pvIndex = -1;			// ݕ\̃vr[
int		nTime	= 0;			// vr[o^iÂ̌j

// =====================================================
// vr[֘A

// -----------------------------------------------------
//	1.	{ꖼ
//		vr[ϐ̏
//	2.	
//		Ȃ
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void pvInitialize( void )
{
	ZeroMemory( tPreview, sizeof( tPreview ) );
	ZeroMemory( tBmpview, sizeof( tBmpview ) );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		gp̃vr[
//	2.	
//		Ȃ
//	3.	Ԓl
//		-1	...	󂫖
//		n	...	󂫃vr[ւ̃CfbNX
//	4.	l
//		ʏA󂫂ȂĂꍇ͂ƂÂ
//		vr[폜ċ󂫂쐬B
//		-1 Ԃ͓̂ȏꍇ̂݁B
// -----------------------------------------------------
int pvBlankIndex( void )
{
	int i, j, p;
	j = 0x7FFFFFFF;
	for( i=0; i<PV_MAX; ++i ){
		if( tPreview[i].hBmp == NULL ) return i;
		if( tPreview[i].nTime < j ) {
			j = tPreview[i].nTime;	//	łӂ邢vr
			p = i;
		}
	}
	//	󂫂ꍇ͍łӂ邢̂폜
	if( j == 0x7FFFFFFF ) return -1;						//	vr[f[^Ăꍇ or QOȏϊꍇ (^_^;
	pvDelete( p );
	return p;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		w̃vr[폜
//	2.	
//		Index	...	(I)	폜Ώۂ̃CfbNX
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void pvDelete( int Index )
{
	if( tPreview[Index].hBmp == NULL ) return;
	DeleteObject( tPreview[Index].hBmpSrc );
	DeleteObject( tPreview[Index].hBmp );
	LocalFree( tPreview[Index].bmp );
	tPreview[Index].hBmpSrc = NULL;
	tPreview[Index].hBmp = NULL;
	tPreview[Index].bmp = NULL;
	tPreview[Index].nTime = 0x7FFFFFFF;
	bdDelete(tPreview[Index].nSrc);
	if( pvIndex == Index ) pvIndex = pvNextPreview( pvIndex );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		Svr[폜
//	2.	
//		Ȃ
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void pvAllDelete( void )
{
	int i;
	for( i=0; i<PV_MAX; ++i ){
		pvDelete( i );
	}
	nTime = 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		̃vr[
//	2.	
//		Index	...	(I)	݂̃CfbNX
//	3.	Ԓl
//		-1	...	vr[
//		n	...	̃CfbNX
//	4.	l
//		Ȃ
// -----------------------------------------------------
int pvNextPreview( int Index )
{
	int i;
	Index=(Index+1)%PV_MAX;
	for( i=0; i<PV_MAX; ++i,Index=(Index+1)%PV_MAX ){
		if( tPreview[Index].hBmp != NULL ) return Index;
	}
	return -1;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		Õvr[
//	2.	
//		Index	...	(I)	݂̃CfbNX
//	3.	Ԓl
//		-1	...	vr[
//		n	...	ÕCfbNX
//	4.	l
//		Ȃ
// -----------------------------------------------------
int pvPrevPreview( int Index )
{
	int i;
	Index=(Index-1+PV_MAX)%PV_MAX;
	for( i=0; i<PV_MAX; ++i,Index=(Index-1+PV_MAX)%PV_MAX ){
		if( tPreview[Index].hBmp != NULL ) return Index;
	}
	return -1;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		vr[Ƀrbg}bvǉ
//	2.	
//		Index	...	(I)	󂫃vr[̃CfbNX
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -----------------------------------------------------
bool pvAddPreview( int Index )
{
	HDC hDC;
	if( tPreview[ Index ].hBmp != NULL || Index<0 ) return false;
	hDC = GetDC( NULL );
	tPreview[ Index ].hBmp    = CreateCompatibleBitmap( hDC, cnMAXWidth, cnMAXHeight );
	tPreview[ Index ].hBmpSrc = CreateCompatibleBitmap( hDC, cnMAXWidth, cnMAXHeight );
	ReleaseDC( NULL, hDC );
	if( tPreview[ Index ].hBmp    == NULL ||
		tPreview[ Index ].hBmpSrc == NULL ){	// 쐬Ɏs烁ăG[Ԃ
		if( tPreview[ Index ].hBmp    != NULL ) DeleteObject( tPreview[ Index ].hBmp    );
		if( tPreview[ Index ].hBmpSrc != NULL ) DeleteObject( tPreview[ Index ].hBmpSrc );
		tPreview[ Index ].hBmp    = NULL;
		tPreview[ Index ].hBmpSrc = NULL;
		tPreview[ Index ].nTime   = 0x7FFFFFFF;
		return false;
	}
	tPreview[ Index ].nTime = nTime;
	if( nTime < 0x7FFFFFFF ) ++nTime;
	return true;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		vr[iϊjɃrbg}bv`悷
//	2.	
//		hDC		...	(I)	foCXiꎞIɎgpj
//		Index	...	(I)	vr[̃CfbNX
//		in		...	(I)	摜C[W
//		width	...	(I)	摜C[W̕
//		height	...	(I)	摜C[W̍
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void pvDrawBmp( HDC hDC, int Index, COLORREF *in, int width, int height )
{
	RECT	r = { 0, 0, cnMAXWidth, cnMAXHeight };
	int x,y,t,h;
	COLORREF c;

	HBITMAP hMemBM = SelectBitmap( hDC,tPreview[Index].hBmpSrc );	// ꎞIɉzʗpcbgp

	if( (height < 212) || (height == 384) ) {
		t = 212 - 192;
		h = cnMAXHeight - t*2;
		FillRect( hDC, &r, (HBRUSH)GetStockObject( BLACK_BRUSH ) );
		for( y=0; y<h; ++y ){
			for( x=0; x<cnMAXWidth; ++x ){
				c=*( in + x*width/cnMAXWidth + (y*height/h)*width );
				SetPixel( hDC,x,t+y,c );
			}
		}
	} else {
		for( y=0; y<cnMAXHeight; ++y ){
			for( x=0; x<cnMAXWidth; ++x ){
				c=*( in + x*width/cnMAXWidth + (y*height/cnMAXHeight)*width );
				SetPixel( hDC,x,y,c );
			}
		}
	}
	SelectBitmap( hDC,hMemBM );							// ɖ߂
}

// -----------------------------------------------------
//	1.	{ꖼ
//		vr[ԍAԂ֕ϊ
//	2.	
//		Index	...	(I)	vr[̃CfbNX
//	3.	Ԓl
//		Ήԍ
//	4.	l
//		Ȃ
// -----------------------------------------------------
int pvGetNum( int Index )
{
	int i,r;
	if( Index==-1 ) return -1;
	r=0;
	for( i=0; i<=Index; ++i ){
		if( tPreview[i].bmp != NULL ) ++r;
	}
	return r;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		vr[̓o^擾
//	2.	
//		Ȃ
//	3.	Ԓl
//		o^
//	4.	l
//		Ȃ
// -----------------------------------------------------
int pvGetCnt( void )
{
	int i,r;
	r=0;
	for( i=0; i<PV_MAX; ++i ){
		if( tPreview[i].bmp != NULL ) ++r;
	}
	return r;
}

// =====================================================
// 摜t@CC[W֘A

// -----------------------------------------------------
//	1.	{ꖼ
//		gp̉摜t@CC[W
//	2.	
//		Ȃ
//	3.	Ԓl
//		-1	...	󂫖
//		n	...	󂫃vr[̃CfbNX
//	4.	l
//		Ȃ
// -----------------------------------------------------
int bdBlankIndex( void )
{
	int i;

	//	vr[ɋ󂫂΋󂫂
	pvBlankIndex();

	//	󂫂
	for( i=0; i<PV_MAX; ++i ){
		if( tBmpview[i].n == 0 ) return i;
	}
	return -1;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		w̉摜t@CC[W폜
//	2.	
//		Index	...	(I)	폜Ώۂ̉摜CfbNX
//	3.	Ԓl
//		Ȃ
//	4.	l
//		摜݂ȂĂȂB
//		iAA摜Ǘz͏ς݂̏ꍇɌj
// -----------------------------------------------------
void bdDelete( int Index )
{
	if( tBmpview[Index].n == 0 ) return;
	if( (--tBmpview[Index].n)==0 ){
		LocalFree( tBmpview[Index].image );
	}
}

// -----------------------------------------------------
//	1.	{ꖼ
//		BMPt@C摜t@CC[Wɒǉ
//	2.	
//		cszFileName	...	(I)	t@C
//	3.	Ԓl
//		-1	...	ǉɎs
//		n	...	t@CC[W̃CfbNX
//	4.	l
//		摜t@CC[W̎QƃJE^ 1 ɂȂ
// -----------------------------------------------------
static int _bdAddFile( const char *cszFileName ) {
	BITMAPFILEHEADER	bfh;
	int					nSize;
	FU_FILE				*hFile;
	int					nIndex;
	char				szBuf[ MAX_PATH ];

	// 摜t@CC[W̋󂫂
	nIndex = bdBlankIndex();
	if( nIndex == -1 ) return -1;
	// t@CJ
	hFile = fu_open( cszFileName, "rb" );
	if( hFile == FU_INVALID_HANDLE ) {
		wsprintf( szBuf,"%s J܂B",cszFileName );
		MessageBox( NULL,szBuf,MsgCap,MB_OK | MB_ICONWARNING );
		return -1;	// t@CI[vs
	}
	// t@CTCY
	nSize = (int)fu_length( hFile )-sizeof(bfh);
	if( nSize < sizeof(BITMAPINFOHEADER) ) goto exit;

		// t@Cwb_ǂݍ
	if( !fu_read( hFile, &bfh, sizeof(bfh) ) ) goto exit;

	// wb_mF
	if( bfh.bfType != 'MB' ) goto exit;

	// mۂ
	tBmpview[ nIndex ].image = (char*)LocalAlloc( LMEM_FIXED | LMEM_ZEROINIT,nSize );
	if( tBmpview[ nIndex ].image==NULL ) goto exit;

	// t@Cǂݍ
	fu_read( hFile, tBmpview[ nIndex ].image, nSize );
	// I
	tBmpview[ nIndex ].n = 1;
	lstrcpy( tBmpview[ nIndex ].sFileName, cszFileName );
	fu_close( hFile );
	return nIndex;
exit:
	fu_close( hFile );
	return -1;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		摜t@C摜t@CC[Wɒǉ
//	2.	
//		cszFileName	...	(I)	t@C
//	3.	Ԓl
//		-1	...	ǉɎs
//		n	...	t@CC[W̃CfbNX
//	4.	l
//		摜t@CC[W̎QƃJE^ 1 ɂȂ
// -----------------------------------------------------
int bdAddFile( const char *cszFileName )
{
	int		nIndex;
	bool	bProg = false;
	char	szBuf[ MAX_PATH ];

	//	BMPt@CƂēǂݍł݂
	nIndex = _bdAddFile( cszFileName );
	if( nIndex > -1 ) return nIndex;

	// 摜t@CC[W̋󂫂
	nIndex = bdBlankIndex();
	if( nIndex == -1 ) return -1;

	//	oߕ\p_CAO\
	GetFileTitle( cszFileName, szBuf, sizeof( szBuf ) );
	prShow( szBuf );

	//	vOCɓǂݍ܂
	tBmpview[ nIndex ].image = spi_load_image( cszFileName, (FARPROC)ProgressCallback );

	//	oߕ\p_CAO
	prDestroy();

	//	G[`FbN
	if( tBmpview[ nIndex ].image == NULL ) return -1;

	// I
	tBmpview[ nIndex ].n = 1;
	lstrcpy( tBmpview[ nIndex ].sFileName , cszFileName );

	return nIndex;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		BMPt@CC[W摜t@CC[Wɒǉ
//	2.	
// 		bmp	...	(I)	alot@CC[W
// 3.	Ԓl
//		-1	...	ǉɎs
//		n	...	t@CC[W̃CfbNX
// 4.	l
//		摜t@CC[W̎QƃJE^ 1 ɂȂ
// -----------------------------------------------------
int bdAddImage( char *bmp )
{
	int					nIndex;
	// 摜t@CC[W̋󂫂
	nIndex = bdBlankIndex();
	if( nIndex == -1 ) return -1;
	// L
	tBmpview[ nIndex ].image = bmp;
	// I
	tBmpview[ nIndex ].n = 1;
	tBmpview[ nIndex ].sFileName[0]='\0';
	return nIndex;
}

// =====================================================
//	R[obN

// -----------------------------------------------------
//	1.	{ꖼ
//		Susie PlugIn p̌oߕ\֐
//	2.	
//		nNum	...	(I)	o
//		nDenom	...	(I)	nNum ̏Il
//		lData	...	(I)	Av`̒ligpj
//	3.	Ԓl
//		0	...	s
//		!0	...	~
//	4.	l
//		prProg Ăяo I/F ֐
// -----------------------------------------------------
static int WINAPI ProgressCallback( int nNum, int nDenom, long lData )
{
	if( nDenom == 0 ) return 0;
	prProg( nNum * 100 / nDenom );
	return 0;
}
