// -----------------------------------------------------
// BMP to MSX
// CEBhE
//									(C)2000/5/6 HRA!
// -----------------------------------------------------

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <htmlhelp.h>		//	HTMLhelp workshop ɕt
#include "Config.h"
#include "winEvent.h"
#include "Resource.h"
#include "Setting.h"
#include "Ver.h"
#include "Convert.h"
#include "ProgProc.h"
#include "string.h"
#include "bsave.h"
#include "utils.h"
#include "SubProc.h"
#include "ScriptProc.h"
#include "winuty.h"
#include "splug.h"
#include "PreView.h"
#include "ProgProc.h"
#include "globals.h"
#include "PlugProc.h"

// -----------------------------------------------------
// ݒ

static const int mode[] = { 2, 3, 5, 6, 7, 8, 10, 12, 5, 6, 7, 8, 10, 12 };	// ʃ[hԍ

// ʃTCY
static const SSIZE ScrSize[]={
	{ 256, 192 },	// screen 2/4
	{  64,  48 },	// screen 3
	{ 256, 212 },	// screen 5
	{ 512, 212 },	// screen 6
	{ 512, 212 },	// screen 7
	{ 256, 212 },	// screen 8
	{ 256, 212 },	// screen 10/11
	{ 256, 212 },	// screen 12
	{ 256, 256 },	// screen 5 (256 lines)
	{ 512, 256 },	// screen 6 (256 lines)
	{ 512, 256 },	// screen 7 (256 lines)
	{ 256, 256 },	// screen 8 (256 lines)
	{ 256, 256 },	// screen 10/11 (256 lines)
	{ 256, 256 },	// screen 12 (256 lines)
};

// tO
bool bSave	= false;	// Iɐݒۑ邩ۂ
bool bSrc	= false;	// vr[\̓\[XہifBXeBl[Vj
bool bData	= true;		// ݒ\邩ۂ

#ifdef _ENGLISH

#define cszFontName	"MS Gothic"						// font
const char *cSetting  = "Setting";
const char *cOriginal = "Original";
const char *cResult	  = "Result";
const char *cClipboard= "Clipboard";
const char *cUse	  = "Use";
const char *cNoUse	  = "No use";
const char *cNonZero  = "No use 'color 0'";
const char *cUseZero  = "use 'color 0'";

const char *cShowSet	  = "[%s]\n"
						"Screen Mode = %s\n"
						"Output = %s\n"
						"Error litter = %s : multiply = 0.%03d : ignore error(max)=%d\n"
						"All custom palette = %s : color 0 = %s\n"
						"Recalc J and K = %s\n"
						"Interace = %s\n"
						"Dither = %s : Dither synthesize = %s\n"
						"Bit = %s\n"
						"SC10-12 algolithm = %s\n"
						"Auto output file name = %s\n"
						"Palette data = %s\n"
						"50%%:50%% net tile = %s\n";

#else

#define cszFontName	"lr SVbN"					// tHg
const char *cSetting  = "ݒ";
const char *cOriginal = "ϊ";
const char *cResult	  = "ϊ";
const char *cClipboard= "دްމ摜";
const char *cUse	  = "gp";
const char *cNoUse	  = "gp";
const char *cNonZero  = "0Ԏgp֎~";
const char *cUseZero  = "0Ԃgp";

const char *cShowSet	  = "[%s]\n"
						"Ӱ = %s\n"
						"o͐ = %s\n"
						"덷gU = %s : W = 0.%03d : ̌덷=%d\n"
						"SŒگ = %s : 0Ԃ̐F = %s\n"
						"JKČvZ = %s\n"
						"ڰ = %s\n"
						"ި = %s : ިލ@ = %s\n"
						"FČx = %s\n"
						"Rٺؽ = %s\n"
						"̧ٖ = %s\n"
						"گďo͕@ = %s\n"
						"50%%:50%% = %s\n";

#endif

// -----------------------------------------------------
// vg^Cv

// ʃCxg
EVENT( onCreate			);
EVENT( onClose			);
EVENT( onCommand		);
EVENT( onDestroy		);
EVENT( onDropFiles		);
EVENT( onLButton		);
EVENT( onRButton		);
EVENT( onPaint			);
EVENT( onInitMenu		);
// t@Cj[Cxg
EVENT( onOpen			);
EVENT( onScript			);
// ݒ胁j[Cxg
EVENT( onDefault		);
EVENT( onSetting		);
EVENT( onPlugIn			);
// wvj[Cxg
EVENT( onHelp			);
EVENT( onVer			);
// ҏWj[Cxg
EVENT( onPaste			);
// vr[j[Cxg
EVENT( onMenuDelete		);
EVENT( onMenuAllDelete	);
EVENT( onMenuSave		);
EVENT( onMenuSaveAs		);
EVENT( onMenuBmpSave	);
EVENT( onMenuRedo		);
EVENT( onMenuData		);
EVENT( onMenuZoomUp		);
EVENT( onMenuZoomDown	);
// vr[ - \ j[Cxg
EVENT( onMenuNext		);
EVENT( onMenuPrev		);
EVENT( onMenuChange		);
EVENT( onMenuOriginal	);

void Converter( SETTING *Mode,int nSrc );
static inline COLORREF GetPix( COLORREF *in,int width,int height,int x,int y );
bool DoEvents( void );	// main.cpp
static void MakeSettingStr( char *szBuf,const char *szTitle,SETTING *Mode );
static void UpdateVScreen( void );
static bool CreatePal( int &n,SETTING *Mode,COLORREF *in,int w,int h,COLORREF *Pal );

// -----------------------------------------------------
// O[oϐ

static HDC		hMemDC = NULL;			// z
static HBITMAP	hMemBM = NULL;			// z
static HDC		hBGDC  = NULL;			// S
static HBITMAP	hBGBM  = NULL;			// S
static HWND		hWnd   = NULL;			// EBhEnh
SETTING NowMode;						// ݂̐ݒ
static SETTING	LastMode;				// ŏIϊݒ
static int		nZoom	= 0;			// \{

extern bool	bRedo;						// ĕϊ̫Đݒ肩

// =====================================================

// -----------------------------------------------------
//	1.	{ꖼ
//		EBhE֐
//	2.	
//		hWnd	...	(I)	EBhEnh
//		msg		...	(I)	bZ[W
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		bZ[W֐Ɉˑ
//	4.	l
//		Ȃ
// -----------------------------------------------------
WINPROC( WndProc )
{
	switch( msg )
	{
		ONEVENT( WM_CREATE		, onCreate		);
		ONEVENT( WM_CLOSE		, onClose		);
		ONEVENT( WM_COMMAND		, onCommand		);
		ONEVENT( WM_DESTROY		, onDestroy		);
		ONEVENT( WM_DROPFILES	, onDropFiles	);
		ONEVENT( WM_LBUTTONDOWN	, onLButton		);
		ONEVENT( WM_RBUTTONDOWN , onRButton		);
		ONEVENT( WM_PAINT		, onPaint		);
		ONEVENT( WM_INITMENU	, onInitMenu	);
	}
	return DEFPROC();
}

// =====================================================
// ʃCxg

// -----------------------------------------------------
//	1.	{ꖼ
//		R}h
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		R}h֐Ɉˑ
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onCommand )
{
	switch( LOWORD( wp ) )
	{
	// j[
	ONEVENT( IDM_EXIT		,onClose		);	// I
	ONEVENT( IDM_OPEN		,onOpen			);	// t@CJ
	ONEVENT( IDM_SCRIPT		,onScript		);	// XNvg[h
	// ҏWj[
	ONEVENT( IDM_PASTE		,onPaste		);	// y[Xg
	// vr[j[
	ONEVENT( IDM_NEXT		,onMenuNext		);	// 
	ONEVENT( IDM_PREV		,onMenuPrev		);	// O
	ONEVENT( IDM_CLEAR		,onMenuDelete	);	// 폜
	ONEVENT( IDM_ALLCLEAR	,onMenuAllDelete);	// S폜
	ONEVENT( IDM_SAVE		,onMenuSave		);	// ۑ
	ONEVENT( IDM_SAVEAS		,onMenuSaveAs	);	// Otĕۑ
	ONEVENT( IDM_BMPSAVE	,onMenuBmpSave	);	// aloŕۑ
	ONEVENT( IDM_REDO		,onMenuRedo		);	// ĕϊ
	ONEVENT( IDM_CHANGE		,onMenuChange	);	// ϊ/ϊʐ؂ւ
	ONEVENT( IDM_DATA		,onMenuData		);	// ݒ̕\؂ւ
	ONEVENT( IDM_ORIGNAL	,onMenuOriginal	);	// IWi摜C[W
	ONEVENT( IDM_ZOOMUP		,onMenuZoomUp	);	// g
	ONEVENT( IDM_ZOOMDOWN	,onMenuZoomDown	);	// k
	// ݒ胁j[
	ONEVENT( IDM_DEFSET		,onDefault		);	// ݒ̏
	ONEVENT( IDM_SETTING	,onSetting		);	// ݒ
	ONEVENT( IDM_PLUGIN		,onPlugIn		);	// vOCݒ
	// wvj[
	ONEVENT( IDM_HELP		,onHelp			);	// wv̕\
	ONEVENT( IDM_VER		,onVer			);	// o[W
	}
	return DEFPROC();
}

// -----------------------------------------------------
//	1.	{ꖼ
//		EBhE
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		-1	...	EBhEs
//		0	...	Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onCreate )
{
	HDC		hDC;
	char	szFileName[ MAX_PATH ];
	char	szBuf[ MAX_PATH ];
	int		i,j,n;
	// vr[̃NA
	pvInitialize();
	// EBhEnh
	::hWnd = hWnd;
	// [hݒNA
	bSave = !( GetCfgFile( &NowMode, CfgFile ) && GetPathFile( PathFile, g_sPlug, sizeof( g_sPlug ) ) );
	spi_initialize( g_sPlug );
	LastMode.Mode = -1;
	// zʂ쐬
	hDC = GetDC( hWnd );
	hMemDC = CreateCompatibleDC( hDC );
	hMemBM = CreateCompatibleBitmap( hDC, cnWidth, cnHeight );
	hBGDC  = CreateCompatibleDC( hDC );
	hBGBM  = LoadBitmap( hIns,MAKEINTRESOURCE( IDB_LOGO ) );
	ReleaseDC( hWnd,hDC );
	if( hMemDC==NULL || hMemBM==NULL || hBGDC ==NULL || hBGBM ==NULL ) return -1;
	SelectBitmap( hMemDC,hMemBM );
	SelectBitmap( hBGDC ,hBGBM  );
	// ʂ̍XV
	UpdateVScreen();
	// R}hC
	if( lstrlen( cmd ) ){
		// 񂩂 " 菜
		i=j=0;
		while( cmd[i]!='\0' && j<MAX_PATH-1 ){
			if( cmd[i]!='"' ){
				szFileName[j]=cmd[i];
				j++;
			}
			i++;
		}
		szFileName[j]='\0';
		// _CAO{bNX\
		GetFileTitle( szFileName, szBuf, sizeof( szBuf ) );
		prShow( szFileName );
		// ϊ
		if( (n=bdAddFile( szFileName ))==-1 ){
			MessageBox( hWnd,cszBDErr,MsgCap,MB_OK | MB_ICONWARNING );
			prDestroy();
			return 0;
		}
		Converter( &NowMode,n );
		// p
		if( NowMode.PreView == 1 ){
			bdDelete(n);
		}
		prDestroy();
	}
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		EBhE
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onClose )
{
	DestroyWindow( hWnd );
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		EBhEp
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onDestroy )
{
	if( hBGDC !=NULL ) DeleteDC( hBGDC );
	if( hBGBM !=NULL ) DeleteBitmap( hBGBM );
	if( hMemDC!=NULL ) DeleteDC( hMemDC );
	if( hMemBM!=NULL ) DeleteBitmap( hMemBM );
	pvAllDelete();
	hBGDC =NULL;
	hBGBM =NULL;
	hMemDC=NULL;
	hMemBM=NULL;
	DestroyWindow( hOrgWnd );
	if( bSave ) {
		SaveCfgFile( &NowMode, CfgFile );
		SavePathFile( PathFile, g_sPlug, sizeof( g_sPlug ) );
	}
	bSave = false;
	PostQuitMessage(0);
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		t@Chbv
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onDropFiles )
{
	HDROP	hDrop;
	char	szBuf[ MAX_PATH ];
	int		i,j,n;
	hDrop = (HDROP)wp;
	SETTING	tmp;

	// t@C擾
	j=DragQueryFile( hDrop, 0xFFFFFFFFL, szBuf, MAX_PATH );
	//	o߂\
	prShow( "" );
	// St@C
	for( i=0;i<j;i++ ){
		// hbvꂽt@C擾
		DragQueryFile( hDrop, i, szBuf, MAX_PATH );
		// o߂Ƀt@C\
		prSetText( szBuf );
		// t@Cϊ
		if( (n=bdAddFile( szBuf ))==-1 ){
			MessageBox( hWnd, cszBDErr, MsgCap, MB_OK | MB_ICONWARNING );
			break;
		}
		switch( NowMode.CnvMode ) {
		case CM_DEFAULT:
			tmp = NowMode;
			break;
		case CM_LAST:
			if( LastMode.Mode == -1 ) {
				tmp = NowMode;
			} else {
				tmp = LastMode;
			}
			break;
		case CM_IMAGE:
			if( pvIndex < 0 ) {
				tmp = NowMode;
			} else {
				tmp = tPreview[ pvIndex ].tMode;
			}
			break;
		}
		Converter( &tmp, n );
		if( tmp.PreView == 1 ){
			bdDelete(n);
		}
	}
	// I
	prDestroy();
	DragFinish( hDrop );
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		}EXNbN
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onLButton )
{
	if( pvIndex==-1 ){
		MessageBox( hWnd, cszMainClk, MsgCapWrn, MB_OK | MB_ICONWARNING );
		return 0;
	}else{
		return CALLEVENT( onMenuRedo );	// ĕϊ
	}
}

// -----------------------------------------------------
//	1.	{ꖼ
//		}EXENbN
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onRButton )
{
	HMENU	hMenu, hSubMenu;
	POINT	p;

	hMenu	= GetMenu( hWnd );
	hSubMenu= GetSubMenu( hMenu, 2 );
	GetCursorPos( &p );
	TrackPopupMenu( hSubMenu, TPM_CENTERALIGN | TPM_VCENTERALIGN | TPM_RIGHTBUTTON, p.x, p.y, 0, hWnd, NULL );
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		ʂ̕`
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onPaint )
{
	HDC			hDC;
	PAINTSTRUCT	ps;
	int			z;
	// XVv̂镔̂ݍXV
	hDC = BeginPaint( hWnd,&ps );
	z = nZoom + 1;
	StretchBlt( hDC, 0, 0, cnWidth * z, cnHeight * z,
			 hMemDC, 0, 0, cnWidth    , cnHeight    , SRCCOPY );
	EndPaint( hWnd,&ps );
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		j[̏
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onInitMenu ) {
	HANDLE			hMem;
	MENUITEMINFO	mi;
	const int pvitem[]={
		IDM_NEXT,IDM_PREV,IDM_CHANGE,IDM_ORIGNAL,IDM_CLEAR,
		IDM_ALLCLEAR,IDM_SAVE,IDM_SAVEAS,IDM_REDO,IDM_BMPSAVE,
	};
	int i;

	// j[ACȅ
	memset( &mi,0,sizeof( mi ) );
	mi.cbSize	= sizeof( mi );
	mi.fMask	= MIIM_STATE;
	// Nbv{[hɉ摜邩mF
	OpenClipboard(hWnd);
	hMem=GetClipboardData( CF_DIB );
	CloseClipboard();
	// ҏW̃y[Xg
	mi.fState	= hMem==NULL ? MFS_GRAYED : MFS_ENABLED;
	SetMenuItemInfo( hMenu,IDM_PASTE,FALSE,&mi );
	// vr[
	mi.fState	= pvIndex==-1 ? MFS_GRAYED : MFS_ENABLED;
	for( i=0; i<ELMCNT( pvitem ); ++i ){
		SetMenuItemInfo( hMenu,pvitem[i],FALSE,&mi );
	}
	return 0;
}

// =====================================================
// [t@C]j[Cxg

// -----------------------------------------------------
//	1.	{ꖼ
//		t@CJ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onOpen )
{
	char	szFileName[ MAX_PATH ];
	char	szBuf[ MAX_PATH ];
#ifdef _ENGLISH
	char	szFilter[ 64 + SPI_MAXLEN ]	= "All Files(*.*)\0*.*\0BMP file(*.BMP)\0*.BMP\0";
	const	int	nextidx = sizeof( "All Files(*.*)\0*.*\0BMP file(*.BMP)\0*.BMP\0" );
#else
	char	szFilter[ 64 + SPI_MAXLEN ]	= "ׂĂ̧(*.*)\0*.*\0BMP ̧(*.BMP)\0*.BMP\0";
	const	int	nextidx = sizeof( "ׂĂ̧(*.*)\0*.*\0BMP ̧(*.BMP)\0*.BMP\0" );
#endif
	OPENFILENAME	ofn;
	int n;
	SETTING	tmp;

	//	tB^̍쐬
	memcpy( &szFilter[ nextidx - 1 ], spi_get_filter(), SPI_MAXLEN );
	
	// t@C
	szFileName[0]='\0';
	ZeroMemory( &ofn,sizeof( ofn ) );
	ofn.lStructSize		= sizeof( ofn );
	ofn.hInstance		= hIns;
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= szFilter;
#ifdef _ENGLISH
	ofn.lpstrTitle		= "Open File";
#else
	ofn.lpstrTitle		= "t@CJ";
#endif
	ofn.lpstrCustomFilter= NULL;
	ofn.nFilterIndex	= 1;
	ofn.Flags			= OFN_LONGNAMES | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;
	ofn.lpstrFile		= szFileName;
	ofn.nMaxFile		= MAX_PATH;
	ofn.lpstrFileTitle	= NULL;
	ofn.lpstrInitialDir	= NULL;	// Jg
	if( !GetOpenFileName( &ofn ) ) return 0;
	// t@Cǂݍ
	if( (n=bdAddFile( szFileName ))==-1 ){
		MessageBox( hWnd,cszBDErr,MsgCap,MB_OK | MB_ICONWARNING );
		return 0;
	}
	// _CAO{bNX\
	GetFileTitle( szFileName, szBuf, sizeof( szBuf ) );
	prShow( szBuf );
	// ϊ
	switch( NowMode.CnvMode ) {
	case CM_DEFAULT:
		tmp = NowMode;
		break;
	case CM_LAST:
		if( LastMode.Mode == -1 ) {
			tmp = NowMode;
		} else {
			tmp = LastMode;
		}
		break;
	case CM_IMAGE:
		if( pvIndex < 0 ) {
			tmp = NowMode;
		} else {
			tmp = tPreview[ pvIndex ].tMode;
		}
		break;
	}
	Converter( &tmp,n );
	//
	if( tmp.PreView == 1 ){
		bdDelete(n);
	}
	prDestroy();
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		XNvg[hEBhE\
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onScript )
{
	DialogBox( hIns,MAKEINTRESOURCE( IDD_SCRIPT ),hWnd,(DLGPROC)ScriptProc );
	return 0;
}

// =====================================================
// [vr[]j[Cxg

// -----------------------------------------------------
//	1.	{ꖼ
//		ݒf[^̕\؂ւ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuData )
{
	bData = !bData;
	UpdateVScreen();
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		ϊ/ϊʂ̕\؂ւ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuChange )
{
	bSrc = !bSrc;
	UpdateVScreen();
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		̃vr[
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuNext )
{
	pvIndex = pvNextPreview( pvIndex );
	UpdateVScreen();
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		Õvr[
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuPrev )
{
	pvIndex = pvPrevPreview( pvIndex );
	UpdateVScreen();
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		vr[̍폜
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuDelete )
{
	if( pvIndex < 0 ) return 0;
	if( MessageBox( hWnd,cszDel,MsgCapWrn,MB_YESNO | MB_ICONWARNING | MB_DEFBUTTON2 )==IDNO ) return 0;
	pvDelete( pvIndex );
	UpdateVScreen();
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		vr[̑S폜
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuAllDelete )
{
	if( pvIndex < 0 ) return 0;
	if( MessageBox( hWnd,cszAllDel,MsgCapWrn,MB_YESNO | MB_ICONWARNING | MB_DEFBUTTON2 )==IDNO ) return 0;
	pvAllDelete();
	pvIndex = -1;
	UpdateVScreen();
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		vr[摜̕ۑ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuSave ) {
	int w,h;
	int	ecode;

	if( pvIndex < 0 ) return 0;
	w=ScrSize[ tPreview[pvIndex].tMode.Mode ].w;
	if( (tPreview[pvIndex].tMode.Mode >= MD_SC5) && !tPreview[pvIndex].tMode.b192 ) {
		h=ScrSize[ tPreview[pvIndex].tMode.Mode ].h;
	} else {
		h=192;
	}
	if( tPreview[pvIndex].tMode.Inter ) h=h*2;
	switch( tPreview[pvIndex].tMode.Mode ) {
	case MD_SC2:
	case MD_SC3:
	case MD_SC5:
	case MD_SC5_256L:
	case MD_SC7:
	case MD_SC7_256L:
		w = w / 2;
		break;
	case MD_SC6:
	case MD_SC6_256L:
		w = w / 4;
		break;
	}
	ecode = bsvSaveBmp( hWnd,tBmpview[tPreview[pvIndex].nSrc].sFileName,
				tPreview[pvIndex].bmp,w,h,&(tPreview[pvIndex].tMode) );
	switch( ecode ) {
	case BSV_ERR_CREATE:
	case BSV_ERR_WRITE:
		MessageBox( hWnd,WriteErr,MsgCap,MB_OK | MB_ICONWARNING );
		break;
	}
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		vr[摜ɖOtĕۑ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuSaveAs ) {
	int w,h;
	int	ecode;
	SETTING tMode;
	if( pvIndex < 0 ) return 0;
	tMode = tPreview[pvIndex].tMode;
	w=ScrSize[ tMode.Mode ].w; 
	if( (tMode.Mode >= MD_SC5) && !tMode.b192 ) {
		h=ScrSize[ tMode.Mode ].h;
	} else {
		h=192;
	}
	if( tMode.Inter ) h = h * 2;
	switch( tPreview[pvIndex].tMode.Mode ) {
	case MD_SC2:
	case MD_SC3:
	case MD_SC5:
	case MD_SC5_256L:
	case MD_SC7:
	case MD_SC7_256L:
		w = w / 2;
		break;
	case MD_SC6:
	case MD_SC6_256L:
		w = w / 4;
		break;
	}
	tMode.AutoName = false;
	ecode = bsvSaveBmp( hWnd,tBmpview[tPreview[pvIndex].nSrc].sFileName,
			 tPreview[pvIndex].bmp,w,h,&tMode );
	switch( ecode ) {
	case BSV_ERR_CREATE:
	case BSV_ERR_WRITE:
		MessageBox( hWnd,WriteErr,MsgCap,MB_OK | MB_ICONWARNING );
		break;
	}
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		aloۑ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuBmpSave )
{
	SETTING	tMode;
	char	sFileName[ MAX_PATH ];
	
	if( pvIndex < 0 ) return 0;
	tMode = tPreview[pvIndex].tMode;

	// t@C
	if( !GetName( hWnd,sFileName, sizeof( sFileName ), cszBmpSave, cszBmpFilter, CfgBmp ) ) return 0;

	//	ۑ
	if( !cnvSaveBmpFile( sFileName, tPreview[ pvIndex ].bmp, cnWidth, cnHeight, &tMode ) ){
		MessageBox( hWnd,WriteErr,MsgCap,MB_OK | MB_ICONWARNING );
		return 0;
	}

	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		g
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuZoomUp )
{
	RECT	r;
	int		z;

	//	g
	nZoom = ( nZoom + 1 ) % cnZoomMax;
	z = nZoom + 1;
	//	EBhE̒
	r.left		= 0;
	r.top		= 0;
	r.right		= cnWidth * z;
	r.bottom	= cnHeight * z;
	AdjustWindowRect( &r,CNWS,TRUE );
	SetWindowPos( hWnd, NULL, 0, 0, r.right - r.left, r.bottom - r.top, SWP_NOMOVE | SWP_NOOWNERZORDER | SWP_NOZORDER );
	InvalidateRect( hWnd, NULL, FALSE );
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		k
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuZoomDown )
{
	RECT	r;
	int		z;

	//	g
	nZoom = ( nZoom + cnZoomMax - 1 ) % cnZoomMax;
	z = nZoom + 1;
	//	EBhE̒
	r.left		= 0;
	r.top		= 0;
	r.right		= cnWidth * z;
	r.bottom	= cnHeight * z;
	AdjustWindowRect( &r,CNWS,TRUE );
	SetWindowPos( hWnd, NULL, 0, 0, r.right - r.left, r.bottom - r.top, SWP_NOMOVE | SWP_NOOWNERZORDER | SWP_NOZORDER );
	InvalidateRect( hWnd, NULL, FALSE );
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		ĕϊ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuRedo )
{
	SETTING Mode;
	char	szBuf[ MAX_PATH ];
	int nSrc;
	if( pvIndex < 0 ) return 0;
	// ݒs
	EdtMode = tPreview[ pvIndex ].tMode;
	LastMode = EdtMode;
	lstrcpy( szCaption,cszRedo );
	bRedo = true;
	if( DialogBox( hIns,MAKEINTRESOURCE( IDD_SETTING ),hWnd,(DLGPROC)SetProc )==0 ){
		// s
		Mode = EdtMode;
		nSrc = tPreview[ pvIndex ].nSrc;
		// _CAO{bNX\
		if( strcmp( cszClipName, tBmpview[ tPreview[ pvIndex ].nSrc ].sFileName ) ) {
			GetFileTitle( tBmpview[ tPreview[ pvIndex ].nSrc ].sFileName, szBuf, sizeof( szBuf ) );
			prShow( szBuf );
		} else {
			prShow( cszClipName );
		}
		// ϊ
		if( Mode.PreView & 2 ) ++tBmpview[nSrc].n;
		Converter( &Mode,nSrc );
		// _CAO
		prDestroy();
	}
	bRedo = false;
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		IWi摜̕\
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onMenuOriginal )
{
	if( pvIndex == -1 ) return 0;	// vr[ꍇ̓IWi\łȂ
	swShow( tBmpview[ tPreview[ pvIndex ].nSrc ].image );
	return 0;
}

// =====================================================
// [ҏW]j[Cxg

// -----------------------------------------------------
//	1.	{ꖼ
//		دްނ璣t
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onPaste	)
{
	HGLOBAL	hMem;
	DWORD	size;
	char *bmp,*mem;
	SETTING	tmp;
	int n;
	// دްނJ
	OpenClipboard(hWnd);
	// rbg}bv擾
	hMem=GetClipboardData( CF_DIB );
	if( hMem==NULL ){
		CloseClipboard();
		return 0;
	}
	size = GlobalSize( hMem );
	// m
	bmp = (char*)LocalAlloc( LMEM_FIXED,size );
	if( bmp==NULL ){
		CloseClipboard();
		return 0;
	}
	mem = (char*)GlobalLock( hMem );
	CopyMemory( bmp,mem,size );
	GlobalUnlock( hMem );
	// دްނ
	CloseClipboard();
	// 摜t@CC[WL
	if( (n=bdAddImage( bmp )) == -1 ){
		MessageBox( hWnd,cszBDErr,MsgCap,MB_OK | MB_ICONWARNING );
		LocalFree( bmp );
		return 0;
	}
	// _CAO{bNX\
	prShow( cszClipName );
	// ϊ
	switch( NowMode.CnvMode ) {
	case CM_DEFAULT:
		tmp = NowMode;
		break;
	case CM_LAST:
		if( LastMode.Mode == -1 ) {
			tmp = NowMode;
		} else {
			tmp = LastMode;
		}
		break;
	case CM_IMAGE:
		if( pvIndex < 0 ) {
			tmp = NowMode;
		} else {
			tmp = tPreview[ pvIndex ].tMode;
		}
		break;
	}
	tmp.AutoName = false;	// t@C͋Iɉ
	Converter( &tmp,n );
	// n
	if( tmp.PreView == 1 ){
		bdDelete(n);
	}
	prDestroy();
	return 0;
}

// =====================================================
// [ݒ]j[Cxg

// -----------------------------------------------------
//	1.	{ꖼ
// 		ftHg̐ݒɖ߂
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onDefault )
{
#ifdef _ENGLISH
	if( MessageBox( hWnd,"Load default setting?","Warning",
					MB_YESNO | MB_ICONWARNING | MB_DEFBUTTON2 )==IDNO ) return 0;
#else
	if( MessageBox( hWnd,"ftHg̐ݒɖ߂܂H","mF",
					MB_YESNO | MB_ICONWARNING | MB_DEFBUTTON2 )==IDNO ) return 0;
#endif
	GetDefCfg(&NowMode);
	bSave = true;
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		j[FZbeBO
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onSetting )
{
	// [hݒҏWGAփRs[
	EdtMode = NowMode;
	lstrcpy( szCaption,cszSetting );
	if( DialogBox( hIns,MAKEINTRESOURCE( IDD_SETTING ),hWnd,(DLGPROC)SetProc )==0 ){
		NowMode = EdtMode;
		bSave = true;
		UpdateVScreen();
	}
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		j[FvOCݒ
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onPlugIn )
{
	if( piShow( hWnd, g_sPlug, sizeof( g_sPlug ) ) == 0 ) {
		//	vOCXgXV
		spi_initialize( g_sPlug );
		bSave = true;
	}
	return 0;
}

// =====================================================
// [wv]j[Cxg

// -----------------------------------------------------
//	1.	{ꖼ
//		j[Fwv
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onHelp )
{
	char szHelpName[ MAX_PATH ], *ptr;

	strcpy( szHelpName, ::__argv[0] );
	ptr = strrchr( szHelpName, '\\' );
	if( ptr != NULL ) {
		strcpy( ptr+1, cszHelpName );
	}

	HtmlHelp( hWnd, szHelpName, HH_DISPLAY_TOPIC, 0 );
	return 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		j[Fo[W
//	2.	
//		hWnd	...	(I)	EBhEnh
//		wp		...	(I)	vp[^
//		lp		...	(I)	kp[^
//	3.	Ԓl
//		0
//	4.	l
//		Ȃ
// -----------------------------------------------------
EVENT( onVer )
{
	DialogBox( hIns,MAKEINTRESOURCE( IDD_VER ),hWnd,(DLGPROC)VerProc );
	return 0;
}

// =====================================================
// [eBeB

// -----------------------------------------------------
//	1.	{ꖼ
//		t@Cϊ
//	2.	
//		Mode	...	(I)	ݒ
//		nSrc	...	(I)	摜t@CC[W̃CfbNX
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void Converter( SETTING *Mode, int nSrc ) {
	COLORREF	*in, *out, Pal[ 256 ];
	LPBYTE		bmp;
	SETTING		tMode;
	TAILPAT		tail[ TAILMAX ];
	int			tailcnt = 0;
	int			width, height, owidth, oheight, wwidth, wheight, n, prv=-1;
	char		*ptr = tBmpview[nSrc].image;
	int			i;
	int			ecode;

	// vr[쐬
	if( Mode->PreView & 2 ){
		prv=pvBlankIndex();
		if( !pvAddPreview( prv ) ){
			MessageBox( hWnd, cszCannotAddPV, MsgCapWrn, MB_OK | MB_ICONWARNING );
			return;
		}
	}
	// ǂݍ
	if( !GetBmp( &in,&width,&height,&ptr ) ){
		MessageBox( hWnd, cszNoSupp, MsgCap, MB_OK | MB_ICONWARNING );
		return;
	}
	// ꍇ̓G[
	if( (width < 8 || height < 8) && Mode->Resize ){
		LocalFree( in );
		MessageBox( hWnd, cszSmall, MsgCap, MB_OK | MB_ICONWARNING );
		return;
	}
	// [̐F擾
	if( Mode->FourceZero == FZ_MATRIX ){
		Mode->FZColor = GetPix( in, width, height, Mode->FZX,Mode->FZY );
	}
	// ϊ̃TCY߁Amۂ
	owidth  = ScrSize[ Mode->Mode ].w;
	if( (Mode->Mode >= MD_SC5) && Mode->b192 ) {
		oheight = 192;
	} else {
		oheight = ScrSize[ Mode->Mode ].h;
	}
	oheight = oheight * ( Mode->Inter ? 2 : 1 );
	out = (COLORREF*)LocalAlloc( LMEM_FIXED,sizeof(COLORREF) * owidth * oheight );
	if( out==NULL ){
		LocalFree( in );
		MessageBox( hWnd, cszNotEnoughMem, MsgCap, MB_OK | MB_ICONWARNING );
		return;
	}
	// wiFŃNA
	for( i = 0; i < owidth * oheight; ++i ) {
		out[ i ] = Mode->FCColor;
	}
	// TCY𒲐߂
	if( Mode->Resize ) {
		//	AXyNg
		switch( Mode->SizeMode ) {
		case RM_MSX:
			if( (Mode->Mode == MD_SC6) || (Mode->Mode == MD_SC7) || (Mode->Mode == MD_SC6_256L) || (Mode->Mode == MD_SC7_256L) ) {
				wwidth  = width  * 5 / 3;	//	 1.66{
				wheight = height;
			} else {
				wwidth  = width;
				wheight = height * 6 / 5;	//	c 1.2{
			}
			if( Mode->Inter ) {
				wheight = wheight * 2;
			}
			//	𒲐
			if( wwidth > owidth ) {
				wheight = wheight * owidth / wwidth;
				wwidth  = owidth;
			}
			//	𒲐
			if( wheight > oheight ) {
				wwidth  = wwidth * oheight / wheight;
				wheight = oheight;
			}
			break;
		default:
			wwidth  = owidth;
			wheight = oheight;
			break;
		}
		//	Tv
		switch( Mode->Resample ) {
		case RS_NORMAL:		//	m[}gk
			cnvNormResize( in, width, height, out, owidth, oheight, wwidth, wheight, prProg,Mode->Seido );
			break;
		case RS_ANTIALIAS:	//	A`GCAXtgk
			cnvAntiResize( in, width, height, out, owidth, oheight, wwidth, wheight, prProg,Mode->Seido );
			break;
		default:			//	TCYߖ
			if( Mode->Inter && Mode->Mode != MD_SC6 && Mode->Mode != MD_SC7 && Mode->Mode != MD_SC6_256L && Mode->Mode != MD_SC7_256L ) {
				cnvCopyInter( in, width, height, out, owidth, oheight, prProg, Mode->Seido );
			}else{
				cnvCopy( in, width, height, out, owidth, oheight, prProg, Mode->Seido );
			}
		}
	} else {
		//	TCY
		if( Mode->Inter && Mode->Mode != MD_SC6 && Mode->Mode != MD_SC7 && Mode->Mode != MD_SC6_256L && Mode->Mode != MD_SC7_256L ) {
			cnvCopyInter( in, width, height, out, owidth, oheight, prProg, Mode->Seido );
		}else{
			cnvCopy( in, width, height, out, owidth, oheight, prProg, Mode->Seido );
		}
	}

	LocalFree(in);
	in=NULL;
	// vr[Ό摜ۑ
	if( Mode->PreView & 2 ) pvDrawBmp( hMemDC, prv, out, owidth, oheight );
	// pbg߂
	if( !CreatePal( n, Mode, out, owidth, oheight, Pal ) ){
		LocalFree( out );
		return;
	}
	//	گĂĂ
	if( Mode->Mode < MD_SC8 || (Mode->Mode >= MD_SC5_256L && Mode->Mode < MD_SC8_256L) ) {
		if( !( Mode->Pal && ((Mode->SortMode == SM_INCAUTO) || (Mode->SortMode == SM_INCAUTO)) ) ) {
			cnvSortPalette( Mode, Pal );
		}
	}
	// ^Cp^[߂
	if( Mode->Tile ){
		switch( Mode->Mode ){
		case MD_SC2:
		case MD_SC3:
		case MD_SC5:
		case MD_SC6:
		case MD_SC7:
		case MD_SC5_256L:
		case MD_SC6_256L:
		case MD_SC7_256L:
			tailcnt = cnvCreateTail4( Mode->Col, Mode->PalEn, !Mode->NonZero, tail, Mode->Mode );
			break;
		}
	}
	// ϊʂi[郁mۂ
	bmp = (BYTE*)LocalAlloc( LMEM_FIXED | LMEM_ZEROINIT,0x20000 );	//	128KBmہiVRAMC[Wj
	if( bmp==NULL ){
		MessageBox( NULL,cszNotEnoughMem,MsgCap,MB_OK | MB_ICONWARNING );
		return;
	}
	// ϊ(COLORREFz񁨂lrw摜)
	if( Mode->Mode < MD_SC10 || (Mode->Mode >= MD_SC5_256L && Mode->Mode <= MD_SC10_256L) ) {	// Screen10/12 ȊO
		cnvRecolor( out, owidth, oheight, bmp, Mode, prProg, Pal, tail, tailcnt );
	}else{							// Screen10/12
		cnvNtcolor( out, owidth, oheight, bmp, Mode, prProg );
	}
	LocalFree( out );
	out=NULL;
	// tH[JXڂ
	SetFocus( hWnd );
	// ϊʂۑ
	if( n == 16) owidth /= 2; else if( n == 4 ) owidth /= 4;
	if( Mode->PreView & 1 ){
		tMode = *Mode;
		if( tBmpview[nSrc].sFileName[0]=='\0' ){			// Nbv{[h̏ꍇ̓t@C͖
			tMode.AutoName = false;
		}
		ecode = bsvSaveBmp( hWnd,tBmpview[nSrc].sFileName,bmp,owidth,oheight,Mode );
		switch( ecode ) {
		case BSV_ERR_CREATE:
		case BSV_ERR_WRITE:
			MessageBox( hWnd,WriteErr,MsgCap,MB_OK | MB_ICONWARNING );
			break;
		}
	}
	if( Mode->PreView & 2 ){
		tPreview[prv].bmp=bmp;								// ϊ VRAM C[WL
		tPreview[prv].tMode=*Mode;							// ݂̐ݒL
		tPreview[prv].nSrc = nSrc;							// vr[̌t@C
		SelectBitmap( hMemDC,tPreview[prv].hBmp );			// vr[쐬
		DrawScreen( bmp,hMemDC,Mode );
		SelectBitmap( hMemDC,hMemBM );						// ɖ߂
		pvIndex = prv;										// ̃vr[\
		bSrc=false;											// ϊʂ̉摜\
		UpdateVScreen();									// ʂ̍XV
		return;
	}
	// ̉
	LocalFree( bmp );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		sNZl擾
//	2.	
//		in		...	(I)	摜
//		width	...	(I)	
//		height	...	(I)	
//		x		...	(I)	wW
//		y		...	(I)	xW
//	3.	Ԓl
//		F
//	4.	l
//		Ȃ
// -----------------------------------------------------
static inline COLORREF GetPix( COLORREF *in,int width,int height,int x,int y )
{
	// ͈͊OC
	if( x<0 ) x=0;
	if( y<0 ) y=0;
	if( x>=width  ) x=width -1;
	if( y>=height ) y=height-1;
	// ẅʒu̐FԂ
	return( *( in + x + (height-y)*width ) );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		pbg̍쐬
//	2.	
//		n		...	(O)		pbg
//		Mode	...	(I/O)	ݒ
//		in		...	(I)		͉摜
//		w		...	(I)		͉摜̕
//		h		...	(I)		͉摜̍
//		Pal		...	(O)		pbg̐FitJ[j
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -----------------------------------------------------
static bool CreatePal( int &n, SETTING *Mode, COLORREF *in, int w, int h, COLORREF *Pal )
{
	COLORREF	*t;
	int			i, j, pp, pnum;

	n = 0;
	if( Mode->Mode<MD_SC8 || (Mode->Mode >= MD_SC5_256L && Mode->Mode < MD_SC8_256L) ){	// Screen 5, 6 or 7
		j=0;
		pp=0;
		if( Mode->Mode == MD_SC6 || Mode->Mode == MD_SC6_256L ) pnum = 4; else pnum = 16;
		for( i = 0 ; i < pnum; ++i ){
			if( Mode->NonZero && i == 0 ) continue;
			if( Mode->PalEn[ i ] == PALEN_NONE ) continue;
			++n;
			if( Mode->PalEn[ i ] == PALEN_USE ){
				Pal[pp]=RGB( cc[ Mode->Col[i].red	],
							 cc[ Mode->Col[i].green	],
							 cc[ Mode->Col[i].blue	] );
				++pp;
			}
		}
		if( n<2 ){
			MessageBox( hWnd, cszPalCnt, MsgCap, MB_OK | MB_ICONWARNING );
			return false;
		}
		if( !Mode->Pal ){		// œKpbg
			t = (COLORREF*)LocalAlloc( LMEM_FIXED | LMEM_ZEROINIT,sizeof( COLORREF)*w*h );	// Ɨ̈̊m
			if( t==NULL ){
				MessageBox( hWnd, cszNotEnoughMem, MsgCap, MB_OK | MB_ICONWARNING );
				return false;
			}
			CopyMemory( t, in, w * h * sizeof( COLORREF ) );
			cnvGetPalette( t, w, h, Pal, Mode->SelCol, n, pp, Mode->FourceZero != FZ_NONE,Mode->FZColor );
			LocalFree( t );
			// œKpbgŒpbg֔f
			j=pp;
			for( i = 0; i < pnum; ++i ){
				if( Mode->NonZero && i==0 ) continue;
				if( Mode->PalEn[i]==PALEN_AUTO ){
					Mode->Col[i].red	= (GetRValue( Pal[j] )+18)*7/255;
					Mode->Col[i].green	= (GetGValue( Pal[j] )+18)*7/255;
					Mode->Col[i].blue	= (GetBValue( Pal[j] )+18)*7/255;
					++j;
				}
			}
		}
		n = pnum;
		// Œpbg
		for( i = 0; i < pnum; ++i ){
			Pal[i] = RGB(	cc[ Mode->Col[i].red   ],
							cc[ Mode->Col[i].green ],
							cc[ Mode->Col[i].blue  ] );
		}
	}else if( Mode->Mode==MD_SC8 || Mode->Mode==MD_SC8_256L ){	// Screen8
		n=256;
		for(i=0;i<256;i++){
			Pal[i] = RGB(	cc[ ( i & 0x1C ) >> 2   ],
							cc[ ( i & 0xE0 ) >> 5   ],
							cb[   i & 0x03          ] );
		}
	}
	return true;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		ʂXV
//	2.	
//		Ȃ
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
static void UpdateVScreen( void )
{
	HDC		hMDC;
	HDC		hDC;
	char	szBuf[ 1000+MAX_PATH ];
	char	sFileName[ 50+MAX_PATH ];
	char	sPrev[ 50 ];
	HFONT	hFont,hOldFont;
	RECT	rtext	= { 20, 240, 494, 404 };
	RECT	r		= { 0, 0, cnWidth, cnHeight }; 
	int		z;
	// DC̊m
	hDC=GetDC( hWnd );
	// zʂɉ摜`
	if( pvIndex == -1 ){
		StretchBlt( hMemDC, 0, 0, cnWidth, cnHeight, hBGDC, 0, 0, cnBGWidth, cnBGHeight, SRCCOPY );
	}else{
		hMDC = CreateCompatibleDC( hDC );
		if( bSrc ){	// \[X̕\
			SelectBitmap( hMDC, tPreview[pvIndex].hBmpSrc );
		}else{		// fBXeBl[V̕\
			SelectBitmap( hMDC, tPreview[pvIndex].hBmp );
		}
		FillRect( hMemDC, &r, (HBRUSH) GetStockObject( WHITE_BRUSH ) );
		BitBlt( hMemDC, 0, 0, cnWidth, cnHeight, hMDC,0,0, SRCCOPY );
		if( hMDC!=NULL ) DeleteDC( hMDC );
	}
	// ݒ`
	SetBkColor( hMemDC,cnDataBk1 );
	if( pvIndex == -1 ){
		MakeSettingStr( szBuf,cSetting,&NowMode );
	}else{
		wsprintf( sPrev,"(%d/%d) [%s]",pvGetNum( pvIndex ),pvGetCnt(),( bSrc ? cOriginal : cResult ) );
		if( bSrc ) SetBkColor( hMemDC,cnDataBk2 );
		if( tBmpview[tPreview[pvIndex].nSrc].sFileName[0]=='\0' ){
			lstrcpy( sFileName,cClipboard );
		}else{
			GetFileTitle( tBmpview[tPreview[pvIndex].nSrc].sFileName,sFileName,MAX_PATH );
		}
		lstrcat( sFileName,sPrev );
		MakeSettingStr( szBuf,sFileName,&(tPreview[pvIndex].tMode) );
	}
	if( bData ){
		hFont = CreateFont( 12,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET,
							OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
							DEFAULT_QUALITY,FIXED_PITCH | FF_DONTCARE,cszFontName );
		hOldFont = SelectFont( hMemDC,hFont );
		SetTextColor( hMemDC,cnDataText );
		DrawText( hMemDC,szBuf,lstrlen(szBuf),&rtext,DT_LEFT );
		SelectFont( hMemDC,hOldFont );
		DeleteFont( hFont );
	}
	// ʂɕ`
	z = nZoom + 1;
	StretchBlt( hDC, 0, 0, cnWidth * z, cnHeight * z,
			 hMemDC, 0, 0, cnWidth    , cnHeight    , SRCCOPY );
	ReleaseDC( hWnd,hDC );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		ݒ\p̍쐬
//	2.	
//		szBuf	...	(I)	ݒ蕶̏o͐
//		szTitle	...	(I)	^Cg
//		Mode	...	(I)	ݒe
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void MakeSettingStr( char *szBuf,const char *szTitle,SETTING *Mode )
{
	wsprintf( szBuf,cShowSet,
					szTitle,
					ScrModeName[Mode->Mode],
					PreViewName[Mode->PreView-1],
					(Mode->Gosa  ? cUse : cNoUse),(int)( Mode->Gosaval * 1000 ),Mode->err,
					(Mode->Pal   ? cUse : cNoUse),
					(Mode->NonZero ? cNonZero : cUseZero),
					(Mode->JKrc  ? cUse : cNoUse),
					(Mode->Inter ? cUse : cNoUse),
					ErrAlgoName[Mode->ErrAlgo],ErrAlgo2Name[Mode->ErrAdd],
					ColorSeido[Mode->Seido],
					AlgoName[Mode->AlgoMode],
					(Mode->AutoName ? cUse : cNoUse),
					PltMode[Mode->PltMode],
					(Mode->Tile ? cUse : cNoUse) );
}
