// -------------------------------------------------------------
//	TITLE		:	Windows Utility
//	FILE		:	winuty.h
//	COPYRIGHT	:	(C)2001 t.hara
//	COMENT		:	Windows ⏕֐Q
//	HISTORY		:	2001/02/11	v0.00	Jn
// -------------------------------------------------------------

#ifndef	_winuty_h_
#define	_winuty_h_

// =============================================================
//	CN[h

#include <windows.h>
#include <commctrl.h>											//	RRg[

// =============================================================
//	֐vg^Cv

#define	ELMCNT( a )	( sizeof( a ) / sizeof( (a)[0] ) )

// =============================================================
//	AvP[VW

// -------------------------------------------------------------
//	1.	{ꖼ
//		CX^Xnho^
//	2.	
//		h_ins	...	(I)	CX^Xnh
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_set_instance( HINSTANCE h_ins );

// -------------------------------------------------------------
//	1.	{ꖼ
//		CX^Xnh擾
//	2.	
//		Ȃ
//	3.	Ԓl
//		o^CX^Xnh
//	4.	l
//		Ȃ
// -------------------------------------------------------------
HINSTANCE wu_get_instance( void );

// -------------------------------------------------------------
//	1.	{ꖼ
//		bZ[W
//	2.	
//		Ȃ
//	3.	Ԓl
//		true	...	
//		false	...	AvP[VIv
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool wu_do_events( HWND h_wnd, HACCEL h_accel );

// -------------------------------------------------------------
//	1.	{ꖼ
//		ʓIȃEBhENX̐ݒ
//	2.	
//		p_wndclass	...	(O)	EBhENX\
//		p_class		...	(I)	EBhENX
//		n_icon		...	(I)	ACRhc
//		p_wndclass	...	(I)	EBhE֐
//	3.	Ԓl
//		Ȃ
//	4.	l
//		̊֐gO wu_set_instance ŃCX^Xnh
//		w肵Ă˂΂ȂȂ
// -------------------------------------------------------------
void wu_get_wndclassex( WNDCLASSEX* p_wndclass, const char* p_class, int n_icon, WNDPROC p_wndproc );

// -------------------------------------------------------------
//	1.	{ꖼ
//		EBhEݒ
//	2.	
//		*p_create		...	(O)	EBhE\
//		*p_class		...	(I)	EBhENX
//		*p_caption		...	(I)	EBhE^Cg
//		n_width			...	(I)	EBhE
//									0 ... ȗƌȂftHglݒ肷
//		n_height		...	(I)	EBhE
//									0 ... ȗƌȂftHglݒ肷
//	3.	Ԓl
//		Ȃ
//	4.	l
//		EBhEʒu͉ʂ̒t߂ɐݒ肳
// -------------------------------------------------------------
void wu_get_createstruct( CREATESTRUCT* p_create,const char* p_class, const char* p_caption, 
						  int n_width, int n_height );

// -------------------------------------------------------------
//	1.	{ꖼ
//		EBhE̍쐬
//	2.	
//		p_create	...	(I)	EBhEp[^
//	3.	Ԓl
//		NULL		...	EBhEs
//					...	EBhẼEBhEnh
//	4.	l
//		EBhEsv͎̂Q
//			(1)	EBhEp[^ɕsꍇ
//			(2)	WM_CREATE Cxg -1 Ԃꂽꍇ
//		̊֐̌Ăяô݂ł͂ʂłȂB֐Ă
//		oOɃO[oϐɋKli[AWM_CREATE ̏
//		擪ɂĕʂ̋Kli[B̃O[oϐQƂ
//		邱Ƃŋʂ邱ƂłB
// -------------------------------------------------------------
HWND wu_create_window( CREATESTRUCT* p_create );

// -------------------------------------------------------------
//	1.	{ꖼ
//		st@C݂̑fBNg擾
//	2.	
//		p_buffer	...	(O)	pXo͂obt@̃AhX
//	3.	Ԓl
//		Ȃ
//	4.	l
//		obt@ MAX_PATH ̃TCYmۂĂΏ\
// -------------------------------------------------------------
void wu_get_exe_path( char* p_buffer );

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@CJ_CAO\iPƃt@Cj
//	2.	
//		h_wnd		...	(I)		eEBhEnh
//		p_name		...	(I/O)	ftHgt@C
//								Iꂽt@Ci[B
//		p_filter	...	(I/O)	gq
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool wu_dialog_select_open_file( HWND h_wnd, char* p_name, const char* p_filter );

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@CJ_CAO\it@Cj
//	2.	
//		h_wnd		...	(I)		eEBhEnh
//		p_name		...	(I/O)	ftHgt@C
//								Iꂽt@Ci[B
//		p_filter	...	(I/O)	gq
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		p_name  MAX_PATH ̃TCYKv
// -------------------------------------------------------------
bool wu_dialog_multi_select_open_file( HWND h_wnd, char* p_name, const char* p_filter );

// =============================================================
//	EBhEėp֐

// -------------------------------------------------------------
//	1.	{ꖼ
//		NCAg̈̃TCYw
//	2.	
//		h_wnd		...	(I)	EBhEnh
//		n_width		...	(I)	
//		n_height	...	(I)	
//	3.	Ԓl
//		Ȃ
//	4.	l
//		̎sAݒs\Ȃ炠߂
// -------------------------------------------------------------
void wu_set_client_rect( HWND h_wnd, int n_width, int n_height );

// -------------------------------------------------------------
//	1. ֐
//		EBhE  w̃EBhE ̒ֈړ
//	2. 
//		h_wnd		...	(I)	Ώۂ̃EBhEnh
//		h_basewnd	...	(I)	̃EBhEnh
//	3. Ԓl
//		Ȃ
//	4. l
//		ƑΏۂ̃EBhE̐eq֌WȂǂ͖Ȃ
//		 NULL ɂƃfXNgbvɂ
// -------------------------------------------------------------
void wu_move_center( HWND h_wnd, HWND h_basewnd );

// =============================================================
//	Xgr[֘A

// -------------------------------------------------------------
//	1.	{ꖼ
//		̐擾
//	2.	
//		h_wnd		...	(I)	eEBhEnh
//		n_id		...	(I)	Xgr[̂hc
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
int wu_listview_get_column_count( HWND h_wnd, int n_id );

// -------------------------------------------------------------
//	1.	{ꖼ
//		ǉ
//	2.	
//		h_wnd		...	(I)	eEBhEnh
//		n_id		...	(I)	Xgr[̂hc
//		s_name		...	(I)	
//		n_width		...	(I)	
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_listview_add_column( HWND h_wnd, int n_id, const char* s_name, int n_width );

// -------------------------------------------------------------
//	1.	{ꖼ
//		ڐ擾
//	2.	
//		h_wnd	...	(I)	eEBhE
//		n_id	...	(I)	Xgr[̂hc
//	3.	Ԓl
//		ڐ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
int wu_listview_get_count( HWND h_wnd, int n_id );

// -------------------------------------------------------------
//	1.	{ꖼ
//		Vڂ̒ǉ
//	2.	
//		h_wnd	...	(I)	eEBhE
//		n_id	...	(I)	Xgr[̂hc
//		s_name	...	(I)	ǉ鍀ږ
//	3.	Ԓl
//		}ڂ̃CfbNXisԍj
//	4.	l
//		Ȃ
// -------------------------------------------------------------
int wu_listview_add_item( HWND h_wnd, int n_id, const char* s_name );

// -------------------------------------------------------------
//	1.	{ꖼ
//		ڂ̃TuACe̐ݒ
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	Xgr[̂hc
//		n_row	...	(I)	TuACe̍sԍ
//		n_col	...	(I)	TuACe̗ԍ
//		s_name	...	(I)	TuACeɐݒ肷镶
//	3.	Ԓl
//		Ȃ
//	4.	l
//		n_col  0 ɂƍږύXł
// -------------------------------------------------------------
void wu_listview_set_subitem( HWND h_wnd, int n_id, int n_row, int n_col,const char* s_name );

// =============================================================
//	R{{bNX֘A

// -------------------------------------------------------------
//	1.	{ꖼ
//		R{{bNXɕ̕ǉ
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	R{{bNXID
//		s_array	...	(I);	|C^̔zAhX
//		n_count	...	(I);	s_array ̗vf
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_combo_set_items( HWND h_wnd, int n_id, const char* s_array[], int n_count );

// -------------------------------------------------------------
//	1.	{ꖼ
//		R{{bNX̑IJ[\ʒuw肷
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	R{{bNXID
//		n_index	...	(I);	Iʒu
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_combo_set_index( HWND h_wnd, int n_id, int n_index );

// -------------------------------------------------------------
//	1.	{ꖼ
//		R{{bNX̑IJ[\ʒu擾
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	R{{bNXID
//	3.	Ԓl
//		CfbNXl
//	4.	l
//		Ȃ
// -------------------------------------------------------------
int wu_combo_get_index( HWND h_wnd, int n_id );

// =============================================================
//	{^֘A

// -------------------------------------------------------------
//	1.	{ꖼ
//		{^ɃACRZbg
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	{^ID
//		hIcon	...	(I);	ZbgACR
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_button_set_icon( HWND h_wnd, int n_id, HICON hIcon );

// -------------------------------------------------------------
//	1.	{ꖼ
//		{^̃`FbNԂZbg
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	{^ID
//		b_check	...	(I);	`FbN
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_button_set_check( HWND h_wnd, int n_id, bool b_check );

// -------------------------------------------------------------
//	1.	{ꖼ
//		{^̃`FbNԂ擾
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	{^ID
//	3.	Ԓl
//		true	...	`FbNς
//		false	...	`FbNAOC
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool wu_button_get_check( HWND h_wnd, int n_id );

// =============================================================
//	j[֘A

// -------------------------------------------------------------
//	1.	{ꖼ
//		j[̃`FbNԂw肷
//	2.	
//		h_wnd	...	(I);	j[EBhEnh
//		n_id	...	(I);	j[ACeID
//		b_check	...	(I);	`FbN
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_menu_set_check( HWND h_wnd, int n_id, BOOL b_check );

// -------------------------------------------------------------
//	1.	{ꖼ
//		j[̗Lݒ肷
//	2.	
//		h_wnd	...	(I);	j[EBhEnh
//		n_id	...	(I);	j[ACeID
//		b_enable	...	(I);	L
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_menu_enabled( HWND h_wnd, int n_id, BOOL b_enable );

// =============================================================
//	Xg{bNX֘A

// -------------------------------------------------------------
//	1.	{ꖼ
//		Xg{bNXɕ̕ǉ
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	Xg{bNXID
//		s_array	...	(I);	|C^̔zAhX
//		n_count	...	(I);	s_array ̗vf
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_list_set_items( HWND h_wnd, int n_id, const char* s_array[], int n_count );

// -------------------------------------------------------------
//	1.	{ꖼ
//		Xg{bNXɕǉ
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	Xg{bNXID
//		s_name	...	(I);	
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_list_add_item( HWND h_wnd, int n_id, const char* s_name );

// -------------------------------------------------------------
//	1.	{ꖼ
//		Xg{bNXɂ
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	Xg{bNXID
//		s_name	...	(I);	
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_list_clear( HWND h_wnd, int n_id );

// -------------------------------------------------------------
//	1.	{ꖼ
//		Xg{bNX̑IJ[\ʒuw肷
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	Xg{bNXID
//		n_index	...	(I);	Iʒu
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_list_set_index( HWND h_wnd, int n_id, int n_index );

// -------------------------------------------------------------
//	1.	{ꖼ
//		Xg{bNX̑IJ[\ʒu擾
//	2.	
//		h_wnd	...	(I);	eEBhEnh
//		n_id	...	(I);	Xg{bNXID
//	3.	Ԓl
//		CfbNXl
//	4.	l
//		Ȃ
// -------------------------------------------------------------
int wu_list_get_index( HWND h_wnd, int n_id );

// =============================================================
//	^uRg[֘A

// -------------------------------------------------------------
//	1.	{ꖼ
//		^uRg[̍ڐ擾
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	^uRg[ID
//	3.	Ԓl
//		ڐ
//	4.	l
//		s 0 Ԃ
// -------------------------------------------------------------
int wu_tab_get_count( HWND h_wnd, int n_id );

// -------------------------------------------------------------
//	1.	{ꖼ
//		^uRg[ɍڂǉ
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	^uRg[ID
//		s_name	...	(I)	ǉ^u
//	3.	Ԓl
//		-1	...	s
//			...	V^ũCfbNX
//	4.	l
//		o^ς݃^u̍Ōɒǉ
// -------------------------------------------------------------
int wu_tab_add_item( HWND h_wnd, int n_id, const char* s_name );

// -------------------------------------------------------------
//	1.	{ꖼ
//		^uRg[ɕ̕ǉ
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	^uRg[ID
//		s_array	...	(I)	|C^̔zAhX
//		n_count	...	(I)	s_array ̗vf
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_tab_set_items( HWND h_wnd, int n_id, const char* s_array[], int n_count );

// =============================================================
//	c[`bv

// -------------------------------------------------------------
//	1.	{ꖼ
//		c[`bv쐬
//	2.	
//		hWnd	...	(I)	eEBhEnh
//	3.	Ԓl
//		!NULL	...	c[`bṽEBhEnh
//		NULL	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
HWND wu_ttip_create( HWND hWnd );

// -------------------------------------------------------------
//	1.	{ꖼ
//		c[`bvɕ\Ώۂǉ
//	2.	
//		hTip	...	c[`bṽnh
//		nId		...	Rg[̂hc
//		s_tips	...	\镶
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
void wu_ttip_set_item( HWND hTip, int nId, char* s_tips );

#endif	//	_winuty_h_
